/* $Header: bus_error.h,v 1.4 89/02/25 01:40:51 gibson Exp $ */
#if	CMU
/***********************************************************************
* HISTORY
*
* 22-Apr-87 Jim Gibson creates file.
*
*/ 
#endif	CMU

/* Data formatting for bus error handler (trap) */


/* Bits in Bus Error Frame's Special Status Word */
#define	FCB	0x8000
#define	FBB	0x4000
#define	RCB	0x2000
#define	RBB	0x1000
#define	DFB	0x0100
#define	RMB	0x0080
#define	RWB	0x0040
#define	SIZ	0x0030
#define	FC	0x0007

/* Types of exception stack frames (nibble) */
#define	NORMAL_4WORD	0x00
#define	THROW_4WORD	0x01
#define	NORMAL_6WORD	0x02
#define	COPR_MIDINST	0x09
#define	SHORT_FORMAT	0x0a
#define LONG_FORMAT	0x0b


/* Offsets (in bytes) into Bus Error Frame */
#define	FTYPE		0x06
#define	SSW		0x0a
#define	DATA_FADDR	0x10
#define	STAGE_B_ADDRESS	0x24


#define frame_byte(addr, field)	((caddr_t)(addr))[(field)]
#define	frame_word(addr, field)	(*(short *)(((caddr_t)(addr)) + field))
#define frame_longword(addr, field)	(*(long *)(((caddr_t)(addr)) + field))

#define	get_frame_format(addr)	(( frame_byte((addr), FTYPE) >> 4) & 0xF)
