/* $Header: /nfs/columbia/u1/BFMACH.local/mk.2.9.6.gibson/bfly2/RCS/conf.c,v 1.82 91/02/15 15:00:21 gibson Exp $ */
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */
 
#include "cputypes.h"

#include "cs_generic.h"
#include "cs_ttyloc.h"
#include "cs_kdb.h"
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)conf.c	7.1 (Berkeley) 6/5/86
 */

#if	CS_GENERIC
#include "../h/param.h"
#else	CS_GENERIC
#include "param.h"
#endif	CS_GENERIC
#include "systm.h"
#include "buf.h"
#include "ioctl.h"
#include "tty.h"
#include "conf.h"
#include "lock.h"
#include "../butterflydev/mbvar.h"
#include "../butterfly/ioconf.h"

int	nulldev();
int	nodev();

#include "eg.h"
int neg = NEG;

#include "sha.h"
int	nsha = NSHA;

#if NSHA == 0
/*
 * If there is no SCSI host adaptor support, then we need a null
 * 'shasetup' routine
 */
shasetup() {}
#endif NSHA

#include "ex.h"
int	nex = NEX;
#include "plx.h"
int	nplx = NPLX;
#include "dr.h"
int	ndr = NDR;
#include "dt.h"
int	ndt = NDT;
#include "exp.h"
int	nexp = NEXP;
#include "vlp.h"
int	nvlp = NVLP;
#include "hps.h"
int	nhps = NHPS;

#if NHPS > 0
int	hpsopen(),hpsclose(),hpsioctl(),hpsread(),hpswrite();
#else NHPS
#define	hpsopen		nodev
#define	hpsclose	nodev
#define	hpsioctl	nodev
#define	hpsread 	nodev
#define	hpswrite	nodev
#endif NHPS

#include "hty.h"
#if NHPS > 0
int	htyopen(),htyclose(),htyread(),htywrite(),htyioctl();
int	htystop(),htyreset(),htyselect();
struct	tty h_tty[];
#else NHPS
#define	htyopen	nodev
#define	htyclose	nodev
#define	htyioctl	nodev
#define	htyread 	nodev
#define	htywrite	nodev
#define	htystop	nodev
#define	htyreset	nodev
#define	htyselect	nodev
#define	h_tty		0
#endif NHPS

#include "vtio.h"
#if NHPS > 0
int	vtio_open(),vtio_close(),vtio_read(),vtio_write(),vtio_ioctl();
#else NHPS
#define	vtio_open		nodev
#define	vtio_close   	nodev
#define	vtio_ioctl	nodev
#define	vtio_read 	nodev
#define	vtio_write	nodev
#endif NHPS

/* $$$ We should get rid of this someday */
#define enptr		0
#define enpioctl	nodev
#define enpreconfig	nodev
#define enpr_open	nodev
#define enpr_close	nodev
#define enpr_read	nodev
#define enpr_write	nodev
#define enpr_ioctl	nodev
#define enpintr		nodev


#include "xy.h"
#if NXYC > 0
int	xyopen(),xyclose(),xystrategy(),xyread(),xywrite(),xyioctl(),xysize();
#else
#define	xyopen		nodev
#define xyclose		nodev
#define	xystrategy	nodev
#define	xyread		nodev
#define	xywrite		nodev
#define	xyioctl		nodev
#define	xysize		0
#endif

#include "tmt.h"
#if NTMTC > 0
int	tmtopen(),tmtclose(),tmtstrategy(),tmtread(),tmtwrite(),tmtioctl();
#else
#define tmtopen		nodev
#define tmtclose	nodev
#define tmtstrategy	nodev
#define tmtread		nodev
#define tmtwrite	nodev
#define tmtioctl	nodev
#endif NTMTC


#include "smt.h"
#if NSMT > 0
int smtopen(), smtclose(), smtread(), smtwrite(), smtioctl(), smtstrategy();
#else
#define smtopen		nodev
#define smtclose	nodev
#define smtread		nodev
#define smtwrite	nodev
#define smtioctl	nodev
#define smtstrategy	nodev
#endif

#if NSHA > 0
int ssmtopen(), ssmtclose(), ssmtread(), ssmtwrite(), ssmtioctl(), ssmtstrategy();
#else
#define ssmtopen		nodev
#define ssmtclose	nodev
#define ssmtread		nodev
#define ssmtwrite	nodev
#define ssmtioctl	nodev
#define ssmtstrategy	nodev
#endif NSHA

#if NSHA > 0
int sdopen(), sdclose(), sdread(), sdwrite(), sdioctl(), sdstrategy(), sdsize();
#else NSHA
#define sdopen		nodev
#define sdclose		nodev
#define sdread		nodev
#define sdwrite		nodev
#define sdioctl		nodev
#define sdstrategy	nodev
#define sdsize		0
#endif NSHA

#include "bbn_stripe.h"
#if BBN_STRIPE > 0
int stripeopen(), stripeclose(), striperead(), stripewrite(), stripeioctl(), 
stripestrategy(), stripesize();
#else BBN_STRIPE
#define stripeopen		nodev
#define stripeclose		nodev
#define striperead		nodev
#define stripewrite		nodev
#define stripeioctl		nodev
#define stripestrategy	        nodev
#define stripesize		0
#endif BBN_STRIPE

#include "bbn_icc.h"
#if BBN_ICC
extern int iccioctl();
extern int iccopen();
#else BBN_ICC
#define iccioctl nodev
#define iccopen  nodev
#endif BBN_ICC

/* the node device is standard, so no #ifdef action here! */
int nodeopen(), nodeclose(), noderead(), nodewrite(), nodeioctl();

/* Backward compatibility with old node driver */
int nodeoldopen(), nodeoldclose(), nodeoldread(), nodeoldwrite();
int nodeoldioctl();

/* the sha device is standard */

int shaopen(), shaclose(), shaioctl();

#define	swstrategy	nodev
#define	swread		nodev
#define	swwrite		nodev

struct bdevsw	bdevsw[] =
{
	{ nodev,	nodev,		nodev,		nodev,	/*0*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*1*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*2*/
	  0,		0, 0 },
	{ xyopen,	xyclose,	xystrategy,	nulldev,	/*3*/
	  xysize,	0, 1 },
	{ tmtopen,	tmtclose,	tmtstrategy,	nulldev,	/*4*/
	  0,		B_TAPE, 0 },
	{ smtopen,	smtclose,	smtstrategy, 	nulldev,	/*5*/
	  0,		B_TAPE, 1 },
	{ ssmtopen,	ssmtclose,	ssmtstrategy,	nulldev,	/*6*/
	  0,		B_TAPE, 1 },
	{ sdopen,	sdclose,	sdstrategy,	nulldev,	/*7*/
	  sdsize,	0, 1 },
	{ stripeopen,	stripeclose,	stripestrategy,	nulldev,	/*8*/
	  stripesize,	0, 1 },
	{ nodev,	nodev,		nodev,		nodev,	/*9*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*10*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*11*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*12*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*13*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*14*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*15*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*16*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*17*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*18*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*19*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*20*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*21*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*22*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*23*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*24*/
	  0,		0, 0 },
	{ nodev,	nodev,		nodev,		nodev,	/*25*/
	  0,		0, 0 },
};
int	nblkdev = sizeof (bdevsw) / sizeof (bdevsw[0]);

int	cnopen(),cnclose(),cnread(),cnwrite(),cnioctl();
struct tty cons;
#if	CS_TTYLOC
int	ncons;
#define	cnntty	(&ncons)
#endif	CS_TTYLOC

#if NDR > 0
int	dropen(),drclose(),drread(),drwrite(),drioctl();
#else
#define dropen		nodev
#define drclose		nodev
#define drread		nodev
#define drwrite		nodev
#define drioctl		nodev
#endif

#if NDT > 0
int	dtopen(),dtclose(),dtioctl();
#else
#define dtopen		nodev
#define dtclose		nodev
#define dtioctl		nodev
#endif

#if NPLX > 0
int	plxopen(),plxclose(),plxioctl();
#else
#define plxopen		nodev
#define plxclose	nodev
#define plxioctl	nodev
#endif

#if NVLP > 0
int	vlpopen(),vlpclose(),vlpread(),vlpwrite();
#else
#define vlpopen		nodev
#define vlpclose	nodev
#define vlpread		nodev
#define vlpwrite	nodev
#define vlpioctl	nodev
#endif

int	syopen(),syread(),sywrite(),syioctl(),syselect();

int 	mmread(),mmwrite();
#define	mmselect	seltrue


#include "pty.h"
#if NPTY > 0
int	ptsopen(),ptsclose(),ptsread(),ptswrite(),ptsstop();
int	ptcopen(),ptcclose(),ptcread(),ptcwrite(),ptcselect();
int	ptyioctl();
struct	tty pt_tty[];
#if	CS_TTYLOC
int	npty;
#define	ptsntty	(&npty)
#endif	CS_TTYLOC
#else
#define ptsopen		nodev
#define ptsclose	nodev
#define ptsread		nodev
#define ptswrite	nodev
#define ptcopen		nodev
#define ptcclose	nodev
#define ptcread		nodev
#define ptcwrite	nodev
#define ptyioctl	nodev
#define	pt_tty		0
#define	ptcselect	nodev
#define	ptsstop		nulldev
#if	CS_TTYLOC
#define	ptsntty		0
#endif	CS_TTYLOC
#endif


int	logopen(),logclose(),logread(),logioctl(),logselect();

int	ttselect(), seltrue();

#if	CS_GENERIC

#include "cmupty.h"
#if	NCMUPTY > 0
int	cmuptyopen(),cmuptyclose(),cmuptyread(),cmuptywrite(),cmuptyioctl();
int	cmuptycopen(),cmuptycclose(),cmuptycread(),cmuptycwrite(),cmuptycioctl();
int	cmuptycselect();
struct tty cmupty_tty[];
#if	CS_TTYLOC
int	ncmupty;
#define	cmuptyntty	(&ncmupty)
#endif	CS_TTYLOC
#else	NCMUPTY
#define	cmuptyopen	nodev
#define	cmuptyclose	nodev
#define	cmuptyread	nodev
#define	cmuptywrite	nodev
#define	cmuptyioctl	nodev
#define	cmuptycopen	nodev
#define	cmuptycclose	nodev
#define	cmuptycread	nodev
#define	cmuptycwrite	nodev
#define	cmuptycioctl	nodev
#define	cmuptycselect	nodev
#define	cmupty_tty	0
#if	CS_TTYLOC
#define	cmuptyntty	0
#endif	CS_TTYLOC
#endif	NCMUPTY

#ifndef butterfly
#### I think we actually want this one!!!
#include "enet.h"
#endif butterfly

#if	NENET > 0
int	enetopen(),enetclose(),enetread(),enetwrite(),enetioctl(),enetselect();
#else	NENET
#define	enetopen	nodev
#define	enetclose	nodev
#define	enetread	nodev
#define	enetwrite	nodev
#define	enetioctl	nodev
#define	enetselect	nulldev
#endif	NENET

/* ### I think we actually DON'T want this one. */
#include "fe.h"
#if	NFE > 0
int	feopen(),feclose(),feread(),fewrite(),feioctl(),fereset();
int	fespread(),fespwrite(),fespioctl();
struct	tty fe_tty[];
/* CS_TTYLOC */
int	nfetty;
#define	fentty	(&nfetty)
/* CS_TTYLOC */
#else	NFE
#define	feopen		nodev
#define	feclose		nodev
#define	feread		nodev
#define	fewrite		nodev
#define	feioctl		nodev
#define	fereset		nulldev
#define	fe_tty		0
#define	fespopen	nodev
#define	fespclose	nodev
#define	fespread	nodev
#define	fespwrite	nodev
#define	fespioctl	nodev
/* CS_TTYLOC */
#define	fentty		0
/* CS_TTYLOC */
#endif	NFE

#include "ild.h"
#if	NILD > 0
#define	ildopen		nulldev
#define	ildclose	nulldev
int ildwrite(), ildioctl();
#else	NILD
#define	ildopen		nodev
#define	ildclose	nodev
#define	ildwrite	nodev
#define	ildioctl	nodev
#endif	NILD
#endif	CS_GENERIC

/*
 * the /dev/vme<N> device always exists
 */
int vmeopen(), vmeclose();

struct cdevsw	cdevsw[] =
{
	cnopen,		cnclose,	cnread,		cnwrite,	/*0*/
	cnioctl,	nulldev,	nulldev,	&cons,
	ttselect,	nodev,
	0,

	xyopen,		xyclose,	xyread,		xywrite,	/*1*/
	xyioctl,	nodev,		nulldev,	0,
	nodev,		nodev,
	1,

	syopen,		nulldev,	syread,		sywrite,	/*2*/
	syioctl,	nulldev,	nulldev,	0,
	syselect,	nodev,
	0,

	nulldev,	nulldev,	mmread,		mmwrite,	/*3*/
	nodev,		nulldev,	nulldev,	0,
	mmselect,	nodev,
	1,

	nulldev,	nulldev,	nodev,		nodev,	       	/*4*/
	nodev,		nodev,		nulldev,	0,
	nodev,		nodev,		
	0,

					/* ENP-30 download driver */
	enpr_open,	enpr_close,	enpr_read,	enpr_write,   	/*5*/
	enpr_ioctl,	nodev,		nulldev,	0,
	nodev,		nodev,		
	0,

	htyopen,	htyclose,	htyread,	htywrite,	/*6*/
 	htyioctl,	htystop,  	htyreset, 	h_tty,   
	htyselect,	0,
	0,

	hpsopen,	hpsclose,	hpsread,	hpswrite,	/*7*/
	hpsioctl,	nodev,  	nodev,	   	0,   
	nodev,		0,
	0,

	vtio_open,	vtio_close,	vtio_read,	vtio_write,	/*8*/
	vtio_ioctl,	nodev, 		nodev,   	0,   
	nodev,		0,
	0,

	tmtopen,	tmtclose,	tmtread,	tmtwrite,	/*9*/
	tmtioctl,	nodev,		nodev,		0,
	nodev,		0,
	0,

	dropen,		drclose,	drread,		drwrite,	/*10*/
	drioctl,	nulldev,	nulldev,	0,
	nodev,		nodev,
	1,

	smtopen, 	smtclose, 	smtread, 	smtwrite,	/*11*/
	smtioctl,	nodev,		nodev,		0,
	nodev,		0,
	1,

	vlpopen,	vlpclose,	vlpread,	vlpwrite,	/*12*/
	nulldev,	nulldev,	nulldev,	0,
	nodev,		nodev,
	1,

	ptsopen,	ptsclose,	ptsread,	ptswrite,	/*13*/
	ptyioctl,	ptsstop,	nulldev,	pt_tty,
	ttselect,	nodev,
	1,

	ptcopen,	ptcclose,	ptcread,	ptcwrite,	/*14*/
	ptyioctl,	nulldev,	nulldev,	pt_tty,
	ptcselect,	nodev,
	1,

	ssmtopen,	ssmtclose,	ssmtread,	ssmtwrite,	/*15*/
	ssmtioctl,	nulldev,	nulldev,	0,
	nodev,		nodev,
	1,

	sdopen,		sdclose,	sdread,		sdwrite,	/*16*/
	sdioctl,	nulldev,	nulldev,	0,
	nodev,		nodev,
	1,

	shaopen,	shaclose,	nodev,		nodev,		/*17*/
	shaioctl,	nulldev,	nulldev,	0,
	nodev,		nodev,
	1,

	dtopen,		dtclose,	nodev,		nodev,		/*18*/
	dtioctl,	nulldev,	nulldev,	0,
	nodev,		nodev,
	1,

	plxopen,	plxclose,	nodev,		nodev,		/*19*/
	plxioctl,	nulldev,	nulldev,	0,
	nodev,		nodev,
	1,

	stripeopen, 	stripeclose, 	striperead, 	stripewrite,	/*20*/
	stripeioctl,	nodev,		nodev,		0,
	nodev,		0,
  	1,

	vmeopen,	vmeclose,	nodev,		nodev,		/*21*/
	nodev,		nodev,		nulldev,	0,
	nodev,		nodev,
	1,

	nodev,		nodev,		nodev,		nodev,		/*22*/
	nodev,		nulldev,	nulldev,	0,
	nodev,		nodev,
	0,

	nodev,		nodev,		nodev,		nodev,		/*23*/
	nodev,		nodev,		nulldev,	0,
	nodev,		nodev,
	0,

	nodev,		nodev,		nodev,		nodev,		/*24*/
	nodev,		nulldev,	nulldev,	0,
	nodev,		nodev,
	1,

	nodev,		nodev,		nodev,		nodev,		/*25*/
	nodev,		nulldev,	nulldev,	0,
	nodev,		nodev,
	1,

	nodeoldopen,	nodeoldclose,	nodeoldread,	nodeoldwrite,	/*26*/
	nodeoldioctl,	nodev,		nodev,		0,
	nodev,		0,
	1,

	iccopen,	nulldev,	nodev,		nodev,		/*27*/
	iccioctl,	nodev,		nodev,		0,
	nulldev,	nulldev,
	1,

	logopen,	logclose,	logread,	nodev,		/*28*/
	logioctl,	nodev,		nulldev,	0,
	logselect,	nodev,
	1,

	nodeopen,	nodeclose,	noderead,	nodewrite,	/*29*/
	nodeioctl,	nodev,		nodev,		0,
	nodev,		0,
	1,

};
int	nchrdev = sizeof (cdevsw) / sizeof (cdevsw[0]);

#if	CS_TTYLOC
int *nttysw[] =
{
    cnntty,	/*  0 */
    0,		/*  1 */
    0,		/*  2 */
    0,		/*  3 */
    0,		/*  4 */
    0,		/*  5 */
    0,		/*  6 */
    0,		/*  7 */
    0,		/*  8 */
    0,		/*  9 */
    0,		/* 10 */
    0,		/* 11 */
    0,		/* 12 */
    0,		/* 13 */
    0,		/* 14 */
    0,		/* 15 */
    0,		/* 16 */
    0,		/* 17 */
    0,		/* 18 */
    0,		/* 19 */
    ptsntty,	/* 20 */
    0,		/* 21 */
    0,		/* 22 */
    0,		/* 23 */
    0,		/* 24 */
    fentty,	/* 25 */
    0,		/* 26 */
    0,		/* 27 */
    cmuptyntty,	/* 28 */
    0,		/* 29 */
    0,		/* 30 */
    0,		/* 31 */
    0,		/* 32 */
    0,		/* 33 */
    0,		/* 34 */
    0,		/* 35 */
    0,		/* 36 */
    0,		/* 37 */
    0,		/* 38 */
    0,		/* 39 */
    0,		/* 40 */
    0,		/* 41 */
    0,		/* 42 */
    0,		/* 43 */
    0,		/* 44 */
    0,		/* 45 */
    0,		/* 46 */
    0,		/* 47 */
    0,		/* 48 */
    0,		/* 49 */
    0,		/* 50 */
};
int	ntty = sizeof (nttysw) / sizeof (nttysw[0]);

#endif	CS_TTYLOC
int	mem_no = 3; 	/* major device number of memory special file */


#if	NQV > 0
int QVSSMAJOR = QVMAJOR;
#endif	NQV > 0

int nointr();

#ifdef	BFLY2
#if BBN_ICC
extern int	icc_handler();	/* ICC interrupt handler */
#else
#define icc_handler nointr
#endif 
extern int	hardclock_interface ();
extern int	softclock_interface ();
extern void	cnintr ();
extern void	tcs_intr ();
extern int	softnetintr ();
extern void	rpc_handler ();
extern int	pmap_update_interrupt ();
extern int	NonMaskableInterrupt ();

#if	CS_KDB
extern int		kdb_interface ();
#else	CS_KDB
#define	kdb_interface	nointr
#endif	CS_KDB

#if	NSMT > 0
extern int		scsi_intr ();
#else	NSMT
#define	scsi_intr	nointr
#endif	NSMT
#if	NTMT > 0
extern int		tmtintr ();
#else	NTMT
#define	tmtintr		nointr
#endif	NTMT
#if	NXY > 0
extern int		xyintr ();
#else	NXY
#define	xyintr		nointr
#endif	NXY
#if	NEG > 0
extern int		egintr();
#else
#define egintr		nointr
#endif
#if	NEX > 0
extern int		exintr ();
#else	NEX
#define	exintr		nointr
#endif	NEX
#if	NHPS > 0
extern int		hps_poll ();
#else	NEX
#define	hps_poll	nointr
#endif	NEX
#if	NPLX > 0
extern int		plxintr ();
#else	NPLX
#define	plxintr		nointr
#endif	NPLX
#if	NDR > 0
extern int		drintr ();
#else	NDR
#define	drintr		nointr
#endif	NDR
#if	NDT > 0
extern int		dtintr ();
#else	NDT
#define	dtintr		nointr
#endif	NDT
#if	NSHA > 0
extern int		shaintr ();
#else	NSHA
#define	shaintr		nointr
#endif	NSHA
#if NEXP > 0
extern	int		expintr();
#else
#define expintr		nointr
#endif

#include "cs_kdb.h"
/*
 * This table is used only by kdb during stack backtraces to detect
 * which routines are interrupt handlers (and therefore should have 
 * exception frames as their first arguments).
 */
int (*InterruptHandlers[])() = {
    shaintr,
    dtintr,
    drintr,
    tmtintr,
    xyintr,
    egintr,
    hps_poll,
    expintr,
    plxintr,
    0
    };

#include "../butterflydev/mbreg.h"
#include "../machine/b2vme.h"
#include "../machine/psl.h"
#include "il_hclk.h"			/* HardClock priority level */
#include "../machine/ioconf.h"

/*
 * See machine/psl.h for Interrupt Level definitions.
 * See machine/ioconf.h for Interrupt Vector definitions.
 * See BUILD/ioconf.c for the IntTable and VecTable arrays,
 * built by 'config'.
 */
extern int (*IntTable[])();
extern int (*VecTable[])();

/*
 * Map interrupt source register (bits 7-4) to interrupt
 * pending bit vector for IL_NMI, IL_ITIMEO, and IL_HCLK.
 */
u_long IsrcPending[] = {
	0x0,					/* 0x00 */
	(1<<IL_NMI),				/* 0x10 */
	0x0,					/* 0x20 */
	(1<<IL_NMI),				/* 0x30 */
	(1<<IL_HCLK),				/* 0x40 */
	(1<<IL_NMI)|(1<<IL_HCLK),		/* 0x50 */
	(1<<IL_HCLK),				/* 0x60 */
	(1<<IL_NMI)|(1<<IL_HCLK),		/* 0x70 */
	(1<<IL_ITIMEO),				/* 0x80 */
	(1<<IL_NMI)|(1<<IL_ITIMEO),		/* 0x90 */
	(1<<IL_ITIMEO),				/* 0xa0 */
	(1<<IL_NMI)|(1<<IL_ITIMEO),		/* 0xb0 */
	(1<<IL_ITIMEO)|(1<<IL_HCLK),		/* 0xc0 */
	(1<<IL_NMI)|(1<<IL_ITIMEO)|(1<<IL_HCLK),/* 0xd0 */
	(1<<IL_ITIMEO)|(1<<IL_HCLK),		/* 0xe0 */
	(1<<IL_NMI)|(1<<IL_ITIMEO)|(1<<IL_HCLK)	/* 0xf0 */
};

/*
 * Interrupt handler called from SCBVEC(interrupt).
 *
 * The rules of the game with regard to the interrupt source register
 * are as follows:
 *
 *	 31     7 6 5 4 3 2 1 0
 *	+------+-+-+-+-+-+-+-+-+
 *	|      | | | | | | | | |	Interrupt Source Register (read only)
 *	+------+-+-+-+-+-+-+-+-+
 *	 unused | | | | +-+-+ |
 *	        | | | |   |   +-- VMEbus interrupt
 *	        | | | |   +------ VMEbus interrupt level (1 - 7)
 *	        | | | +---------- NonMaskable Interprocessor interrupt
 *	        | | +------------ maskable InterProcessor Interrupt
 *	        | +-------------- Real Time Clock interrupt
 *	        +---------------- Interrupts disabled too long TIMEOut
 *
 *	A. VMEbus interrupt(s) are suppost to be cleared by performing
 *	   an IACK operation, but some VME devices (i.e. Multibus adapter
 *	   devices) do not clear until the device interrupt handler tells
 *	   the device to do so.
 *	B. The NonMaskable Interprocessor interrupt is cleared on read.
 *	C. The maskable InterProcessor Interrupt is cleared on read if
 *	   the InterProcessor Interrupt is enabled in the Interrupt
 *	   Enable Mask register.
 *	D. The Real Time Clock interrupt is cleared when a value greater
 *	   than the current time is written to the SIGA's Time Of Next
 *	   Interrupt register.
 *	E. The Interrupts disabled too long TIMEOut interrupt is cleared
 *	   by using the Augmentation Register read-and-clear address.
 *
 * The TC2000 has one interrupt request line on which all interrupt sources
 * are OR'ed together and serviced. Only the VMEbus interrupts are prioritized
 * in hardware. Prioritization of all other interrupts and VMEbus interrupts
 * with respect to other interrupts is done via software emulation.
 *
 * Assumptions:
 *	A. The spl will not be set below the current value within interrupt
 *	   handlers.
 *
 * The software emulation algorithm is as follows:
 *	A. If the current spl is at (or above) the highest interrupt level,
 *	   then just return.
 *	B. Read the interrupt source register.
 *	C. Based on the pending interrupts designated in the source register,
 *	   fill a bit vector of pending interrupts. There should only be bits
 *	   set (interrupts pending) for those levels which are enabled. If
 *	   the interrupt is from a VMEbus device, perform an IACK operation
 *	   and save the returned vector. If there is an InterProcessor
 *	   interrupt, then poll the TCS & Console to set the appropriate
 *	   SIpending bit(s) and then based on the current priority extract
 *	   the pending software interrupts from the SIpending variable and
 *	   OR them into the bit vector.
 *	D. While there are bits set in the pending interrupt vector, process
 *	   them in priority order (first bit set, starting with MSB). This
 *	   entails setting the interrupt mask to block interrupts from all
 *	   sources below and including those of the priority level of the
 *	   interrupt we are currently servicing; enabling interrupts;
 *	   calling the service routine for the given interrupt; and disabling
 *	   interrupts.
 *	E. After processing the pending interrupts, the interrupt mask is
 *	   reset to block interrupts from all sources below and including
 *	   those of the original priority level we were at when we were
 *	   first called.
 *	F. The last operation is to cause a new InterProcessor Interrupt
 *	   if the current priority allows software interrupts and there
 *	   are software interrupts to be processed. This is done because
 *	   the InterProcessor Interrupt bit in the interrupt source register
 *	   is cleared on read.
 */
#include "bbn_assembler_ihandler.h"
#if BBN_ASSEMBLER_IHANDLER
/* in locore_vec.s, part of Xinterrupt() */
#else
ihandler (xframep)
	u_long xframep;
{
	int source, bits;
	u_long mask;
	u_long old_pri;
	u_long ipending;
	u_long first_pri;
	u_long vme_level;
	u_short vme_vector;
	int (*ifunc)();
	int iarg;
	extern int SIpending, XSIpending;
	extern int hardpri;

	/*
	 * If all interrupts are blocked, just return.
	 */
	old_pri = hardpri;
	if (old_pri >= IL_NMI)
		return;

	/*
	 * Read the interrupt source register to see what is pending.
	 */
	source = *((int *)(_INT_SOURCE_REG));

	/*
	 * Cons up a bit vector of the bits coresponding to
	 * the Interrupt Level(s) which are currently pending
	 * and are not blocked.
	 */
	ipending = IsrcPending[(source >> 4) & 0x0f];

	/*
	 * If there is a VMEbus interrupt, then perform an
	 * Interrupt ACKnowledge to quench the interrupt and
	 * to get the VMEbus vector.
	 */
	if (source & ISRC_VME) {
		vme_level = (source >> 1) & (ISRC_VME_LEV >> 1);
		vme_vector = ((u_short *)(VIRT_IACK_BLOCK))[vme_level] & 0xff;
		ipending |= IsrcPendingVME[vme_level];
	}
	
	/*
	 * If there is an InterProcessor Interrupt, then
	 * cons up a bit vector of the bits coresponding to
	 * the Interrupt Level(s) of the Software Interrupt(s)
	 * which are currently pending and are not blocked.
	 */
	if (source & ISRC_IPI) {
	    	extern int XSIpending;
		int shadow = Atomic_clear32(&XSIpending);

		cnintrcheck();		/* poll TCS & console */
#if BBN_ICC
		icc_check();		/* check for ICC interrupts */
#endif
		SIpending |= shadow;
		mask = (0x02 << old_pri) - 1;
		ipending |= (SIpending & ~mask);
		SIpending &= mask;
	}

	/*
	 * While there are interrupts to service,
	 * call the associated interrupt handlers.
	 */
	while (ipending) {
		first_pri = findfirstset(ipending);
		SetEnables(first_pri);
		hardpri = first_pri;
		enable();
		if ((ifunc = IntTable[first_pri]) == VME_VEC) {
			ifunc = my_vme_vec_table[vme_vector].handler;
			iarg = my_vme_vec_table[vme_vector].arg;
			(*ifunc)(iarg, ifunc, vme_vector);
		} else
		    (*ifunc)(xframep, ifunc, 0);
		disable();
		ipending &= ~(1 << first_pri);
	}

	/*
	 * Set the interrupt enable masks to be consistent
	 * with the old priority level and reset hardpri.
	 */
	SetEnables(old_pri);
	hardpri = old_pri;

	/*
	 * It is possible that the interrupt routine posted 
	 * a new software interrupt. If so, and if the previous level
	 * allows it, handle that now.
	 */
	if (old_pri < IL_SI_HIGH) {
	    int mask = (0x02 << old_pri) - 1;
	    
	    if (SIpending & ~mask) {
		enable();
		HandleSI(old_pri, xframep);
		disable();	/* for consistancy */
	    }

}
#endif BBN_ASSEMBLER_IHANDLER

#include "bbn_assembler_setenables.h"
#if BBN_ASSEMBLER_SETENABLES
/* in inline.s */
#else BBN_ASSEMBLER_SETENABLES
/*
 * Hand optimized version in inline.s
 */
SetEnables(level)
{
    u_short x = SetEnables_Table[level];

    *(unsigned int *)(_INT_ENABLE_MASK_REG) = x&0xff;
    *(unsigned int  *)(_TONIA_CONFIG) = (u_int)(x>>8);
    return(level);
}
#endif BBN_ASSEMBLER_SETENABLES

#include "bbn_assembler_handlesi.h"
#if BBN_ASSEMBLER_HANDLESI
/* in locore_vec.s */
#else BBN_ASSEMBLER_HANDLESI
/*
 * HandleSI - process software interrupts
 *
 * called
 *   level - new hardpri level
 *   xframep - pointer to an exception frame.
 *   interrupts disabled
 *
 * returns
 *   interrupts enabled
 *
 * This does not bother with SetEnables because it only operates at
 * levels between 0 and IL_SI_HIGH (exclusive).
 */
void HandleSI(level, xframep)
    int level;
    u_long xframep;
{
    int si, mask, bits;
    int (*ifunc)();
    extern int SIpending;
    extern int hardpri;

    while(1) {
	mask = (0x02 << level) - 1;
	disable();
	if ((bits = (SIpending & ~mask)) == 0) break;

	si = findfirstset(bits);
	SIPending &= ~(1<<si);	/* Clear this bit */
	hardpri = si;
	enable();

	ifunc = IntTable[si];
	(*ifunc)(xframep);
    }

    hardpri = level;		/* Reset to the final level */
    enable();

    return;
}
#endif BBN_ASSEMBLER_HANDLESI

#include "bbn_assembler_splx.h"
#if BBN_ASSEMBLER_SPLX
/* in inline.s */
#else BBN_ASSEMBLER_SPLX
/*
 * splx - set a new interrupt priority level.
 *
 * If the new level allows a software interrupt, then handle it now.
 */
splx(s)
    int s;
{
    int mask, bits, old;
    extern long splXF;		/* A fake exception frame */
    extern int SIpending;
    extern int hardpri;

    if (s == hardpri) return(s); /* Setting to the same level */

    disable();
    SetEnables(s);
    old = hardpri;
    hardpri = s;
    enable();

    mask = (0x02 << s) - 1;
    if (SIpending & ~mask)
	HandleSI(s, &splXF);

    return(old);
}
#endif BBN_ASSEMBLER_SPLX

#endif	BFLY2
