/* $Header: /nfs/europa/u1/BFMACH.local/mk.gibson/bfly2/RCS/paddr.h,v 1.4 90/07/13 13:22:45 gibson Exp $ */

#ifndef _PADDR_H
#define _PADDR_H
#ifdef KERNEL

/*****************************************************************************
* PHYSICAL ADDRESS MANIPULATON
******************************************************************************/

#define	BYTES_PER_NODE		0x00400000	/* 4 Meg nodes */

#define	CMRAM_INDEX_SHIFT	23
#define	CMRAM_ENTRIES		512

#define	PADDR_BYPASS_COMPAT_SHIFT	31
#define	PADDR_BYPASS_COMPAT_MASK	(1 << PADDR_BYPASS_COMPAT_SHIFT)

#ifndef	ASSEMBLER
#define	PAGES_PER_NODE		vm_atop(BYTES_PER_NODE)   /* pages per node */

/* Convert physical (mbus) address into index into cpu mapping rams */
#define	paddr2cmram_index(paddr) (((unsigned)(paddr)) >> CMRAM_INDEX_SHIFT)
#define	cmram_index2paddr(idx)	 (((unsigned)(idx)) << CMRAM_INDEX_SHIFT)

    /* Find physical node on which memory for physical address resides. */
#define vaddr2pnode(addr)	paddr2pnode(svtop((addr)))
    /* Actually, bank offset */
#define	physoffset(paddr)	paddr2bankoffset(paddr)

/* The "compat" notion is an effort to have the same kernel binary support
 * old and new style physical addressing, based on the configuration of
 * the machine.  Thus, it does not get compiled out.
 */
#define	paddrsetbypassed_compat(paddr)	((paddr) | PADDR_BYPASS_COMPAT_MASK)
#define	paddrnonbypassed_compat(paddr)	((paddr) & ~PADDR_BYPASS_COMPAT_MASK)

typedef struct _paddr {
	unsigned int	route: 9;
	unsigned int	offset: 23;
} paddr_t;

#endif ASSEMBLER

/*
 *	This handy physical address is guaranteed to produce an error if
 *	anyone tries to reference it.  Used to set up null mappings
 *	in page tables and mapping rams.
 */
#define	INVALID_PHYS_ADDR	0xE0790000


/* Temporary compatibility with GP-1000.  Leave 64K */
#define	RESERVED_MEM	0x00010000

/* Interprocessor interrupt register occupies 8K of physical address space
 * at offset 8K on a node.
 */
#define	INTREG_OFFSET	0x00002000
#define	INTREG_SIZE	0x00002000

#endif KERNEL

#endif _PADDR_H_
