/* $Header: /nfs/europa/u1/BFMACH.local/mk/bfly2/RCS/paddri.h,v 1.3 90/10/02 11:38:29 lkaplan Exp Locker: lkaplan $ */

#include	"bbn_paddr_table.h"

/*****************************************************************************
* PHYSICAL ADDRESS MANIPULATON
******************************************************************************/

/* physical node number shifted left gives base physical address of node */
#define NODE_TO_MEM_SHIFT	23

/* physical address of first memory location on physical node, 
 * Alternatively, mask to turn physical offset on node into full
 * physical address.
 */
#define NODE_MEM_START(phys_cpu)	((phys_cpu) << NODE_TO_MEM_SHIFT)

#define	PADDR_NODE_MASK		0x1F800000

#define	PADDR_BANK_SHIFT	29
#define	PADDR_BANK_MASK		(3 << PADDR_BANK_SHIFT)
#define	PADDR_BANKOFFSET	0x007FFFFF

/* The BANK_SIZE constants are used for converting physical addresses
 * (with dicontiguous bank bits) into physical offset on a node.  See, for
 * instance, paddr2memoffset().
 */
#define	BANK_SIZE_SHIFT		23		/* 8 Megabytes */
#define	BANK_SIZE		0x00800000	/* 8 Megabytes */

#if BBN_PADDR_TABLE
extern unsigned short	mbus2tbus_map[];

/* Bits in mbus2tbus map entries */
#define	M2TMAP_BANK_MASK	0xC000
#define	M2TMAP_JUNK_MASK	0x2000
#define	M2TMAP_AMOD_MASK	0x1E00
#define	M2TMAP_NODE_MASK	0x01FF

#define	M2TMAP_BANK_SHIFT	14
#define	M2TMAP_MASK_SHIFT	9
#define	M2TMAP_NODE_SHIFT	0

/* "amod" bits */
#define	M2TMAP_BYPASSED		0x01
#define	M2TMAP_IO		0x02
#define	M2TMAP_INTRLVD		0x04
#define M2TMAP_INVALID		0x08

#define	m2tmapext(bits, mask, shift) ((((unsigned)(bits)) & (mask)) >> (shift))

#define	m2tmap2node(entry)	\
  m2tmapext(entry, M2TMAP_NODE_MASK, M2TMAP_NODE_SHIFT)
#define	m2tmap2bank(entry)	\
  m2tmapext(entry, M2TMAP_BANK_MASK, M2TMAP_BANK_SHIFT)
#define	m2tmap2amod(entry)	\
  m2tmapext(entry, M2TMAP_AMOD_MASK, M2TMAP_MASK_SHIFT)

#define	m2tmap_isio(entry)       ((m2tmap2amod(entry) & M2TMAP_IO) != 0)
#define	m2tmap_isbypassed(entry) ((m2tmap2amod(entry) & M2TMAP_BYPASSED) !=0)
#define	m2tmap_isintrlvd(entry)  ((m2tmap2amod(entry) & M2TMAP_INTRLVD) != 0)
#define	m2tmap_isvalid(entry)  ((m2tmap2amod(entry) & M2TMAP_INVALID) == 0)

#define	m2tmapins(bits, mask, shift) ((((unsigned)(bits)) << (shift)) & (mask))

#define	node2m2tmap(node)	\
  m2tmapins(node, M2TMAP_NODE_MASK, M2TMAP_NODE_SHIFT)
#define	bank2m2tmap(entry)	\
  m2tmapins(entry, M2TMAP_BANK_MASK, M2TMAP_BANK_SHIFT)
#define	amod2m2tmap(entry)	\
  m2tmapins(entry, M2TMAP_AMOD_MASK, M2TMAP_MASK_SHIFT)

/* Macros in case anyone needs the speed */
#define	PADDR2PNODE(paddr)	\
  (m2tmap2node(mbus2tbus_map[paddr2cmram_index((unsigned)(paddr))]))
#define	PADDR2BANK(paddr)	\
  (m2tmap2bank(mbus2tbus_map[paddr2cmram_index((unsigned)(paddr))]))
#define	PADDR_ISBYPASSED(paddr)	\
  (m2tmap_isbypassed(mbus2tbus_map[paddr2cmram_index((unsigned)(paddr))]))
#define	PADDR_ISINTRLVD(paddr)	\
  (m2tmap_isintrlvd(mbus2tbus_map[paddr2cmram_index((unsigned)(paddr))]))

#else BBN_PADDR_TABLE

/* Macros in case anyone needs the speed */
#define	PADDR2PNODE(paddr)	\
  ((((unsigned)(paddr)) & PADDR_NODE_MASK) >> NODE_TO_MEM_SHIFT)
#define	PADDR2BANK(paddr)	\
  ((((unsigned)(paddr)) & PADDR_BANK_MASK) >> PADDR_BANK_SHIFT)
#define	PADDR_ISBYPASSED(paddr)	\
  ((((unsigned)(paddr)) & PADDR_BYPASS_COMPAT_MASK) >> PADDR_BYPASS_COMPAT_SHIFT)
#endif BBN_PADDR_TABLE

#define	PADDR2BANKOFFSET(paddr)	(((unsigned)(paddr)) & PADDR_BANKOFFSET)
#define	POFFSET2BANK(offset)	(((unsigned)(offset)) >> BANK_SIZE_SHIFT)
#define	BANK2POFFSET(bank)	(((unsigned)(bank)) << BANK_SIZE_SHIFT)
