/* $Header: /nfs/europa/u1/BFMACH.local/mk/bfly2/RCS/psl.h,v 1.21 90/03/06 06:07:25 tappan Exp $ */

#ifndef	_PSL_H
#define	_PSL_H

#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */ 

/***********************************************************************
* HISTORY
*
*  3-Aug-88	jeff kenton	Butterfly-2
*
*/ 
#endif	CMU
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)psl.h	7.1 (Berkeley) 6/5/86
 */

/*
 * 88000 processor status register
 */

/*
 *	PSR bit number definitions
 */
#define	PSR_mode	31
#define	PSR_bo		30
#define	PSR_ser		29
#define	PSR_c		28
#define	PSR_dexc	27
#define	PSR_sfd1	3
#define	PSR_mxm		2
#define	PSR_ind		1
#define	PSR_sfrz	0

#define PSW_C		(1 << PSR_c)
#define PSW_ALLCC	PSW_C		/* used in wait(), owait() */

#define PSW_IPL		0x0f800000
#define PSW_SUPER	(1 << PSR_mode)

#define	PSW_MBZ		0x6000000f

#define PSW_USERCLR	(PSW_SUPER|PSW_IPL|PSW_MBZ)

/*
 *	Instruction low-order bits
 */
#define	IP_V		2
#define	IP_E		1

/*
 * Invalid status register value.  No spl routine would ever return this.
 * (for a number of reasons, including some bits in psw are always 0).
 */
#define	SPL_INVALID	(-1)

/*
 * Priority based interrupt level indexies into IntTable.
 * 31 is the highest, 0 is the lowest.
 *
 * Interrupt levels are defined dynamically from entries in 
 * the config file.
 *
 * Currently the special cases are
 *
 * IL_NMI - must be 31
 * IL_ITIMEO - must be IL_NMI-1
 * IL_SI_HIGH - must be 15
 * Interrupt Level definitions for hardware generated interrupts.
 */
#define	IL_NMI		31	/* NonMaskable InterProcessor */
#define	IL_ITIMEO	30	/* Interrupt Disabled Timeout */
/*
 * IL_HCLK is defined in a header file produced by the config program
 * To get the definition: '#include "il_hlck.h"'
 */

/*
 * Interrupt Level definitions for software generated interrupts.
 */
#define	IL_SI_HIGH	15	/* unused (highest priority) */


#ifndef ASSEMBLER
#ifdef KERNEL
#include "../h/types.h"
extern int hardpri;
#define gpl() hardpri

/*
 * The IsrcPendingVME table, defined by config in ioconf.c, maps VME
 * interrupt levels to system interrupt levels. It is indexed by 
 * the VME priority and contains a bitmap giving the level.
 */
extern u_long IsrcPendingVME[8];
#define vme2syspri(s) findfirstset(IsrcPendingVME[(s)])

/* PL_TTY defines the highest priority level of a tty device, which
 * is the same value set by spltty.
 */
extern u_char spltty_level;
#define PL_TTY spltty_level
#endif KERNEL
#endif ASSEMBLER
#endif	_PSL_H
