/* $Header: pte.h,v 1.6 89/09/05 20:53:30 gibson Exp $ */
#if	CMU
/* 
 ************************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 ************************************************************************
*/ 
#endif	CMU
#ifndef _PTE_
#define _PTE_
#ifdef	KERNEL
#include "cputypes.h"
#include	"../butterfly/pmap.h"
#else	KERNEL
#include <sys/features.h>
#include <butterfly/pmap.h>
#endif	KERNEL
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)pte.h	7.1 (Berkeley) 6/5/86
 */

#ifndef LOCORE

/*****************************************************************************
* STRUCT PTE STUFF:
* A "struct pte" is the 4.3 notion of a hardware page.  Under Mach it
* may represent several hardware pages, but one system page.
*
* The items in this file are exported for compatibility with 4.3 code,
* which, for example, tends to copy pte's around.
******************************************************************************/

struct pte	{
	pt_entry_t	pte;
};

#ifdef KERNEL
/* Return pte associated with a kernel address */
struct pte *kernel_pte();

/* defined in machdep.c */
extern	struct pte *Sysmap;
#endif	KERNEL

#endif	LOCORE
#endif _PTE_
