/*		$Header: /nfs/europa/u1/BFMACH.local/mk/bfly2/RCS/reg.h,v 1.13 90/04/12 07:50:12 tappan Exp $			*/
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */ 
 
#endif	CMU
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)reg.h	7.1 (Berkeley) 6/5/86
 */

/*
 *	butterfly 2 exception frame definitions
 */

/*
 *	individual item offsets -- each item is an int (4 bytes)
 */
#define XF_type		0	/* frame type */

/*
 *	FP Imprecise Frame -- extra, short, frame
 */
#define XF_fpimpcr	1
#define XF_fprh	  	2
#define XF_fprl		3
#define XF_fpit		4

#define XF_FPSIZE 6	/* must be even */

/*
 *	Basic exception frame
 */

/* Integer Control Unit Registers */
#define XF_tpsr	1
#define XF_ssbr	2		/* only used for debugging */
#define XF_sxip	3
#define XF_snip	4
#define XF_sfip	5
#define XF_dmt0	6
#define XF_dmd0	7
#define XF_dma0	8
#define XF_dmt1	9
#define XF_dmd1	10
#define XF_dma1	11
#define XF_dmt2	12
#define XF_dmd2	13
#define XF_dma2	14

/* general purpose registers */
#define XF_r0	15
#define XF_r1	16
#define XF_r2	17
#define XF_r3	18
#define XF_r4	19
#define XF_r5	20
#define XF_r6	21
#define XF_r7	22
#define XF_r8	23
#define XF_r9	24
#define XF_r10	25
#define XF_r11	26
#define XF_r12	27
#define XF_r13	28
#define XF_r14	29
#define XF_r15	30
#define XF_r16	31
#define XF_r17	32
#define XF_r18	33
#define XF_r19	34
#define XF_r20	35
#define XF_r21	36
#define XF_r22	37
#define XF_r23	38
#define XF_r24	39
#define XF_r25	40
#define XF_r26	41
#define XF_r27	42
#define XF_r28	43
#define XF_r29	44
#define XF_r30	45
#define XF_r31	46

/* Floating Point Control Unit Registers */
#define XF_fpecr 47
#define XF_fphs1 48
#define XF_fpls1 49
#define XF_fphs2 50
#define XF_fpls2 51
#define XF_fppt	 52
#define XF_fpsr  53
#define XF_fpcr  54

/* recovery frame pointer */
#define XF_recovery	55

/* MMU local status registers */
#define XF_dlsr	 56
#define XF_ilsr	 57
#define XF_ilsr2 58

/* struct timeval -- 2 longs */
#define XF_time	 59

/*
 *	exception frame size (in words)
 */
#define	XF_SIZE	 64	/* must be even */


/*
 *	MMU local status register addresses
 */
#define DMMU_lsr	0xFFF7E108
#define IMMU_lsr	0xFFF7F108
#define IMMU2_lsr	0xFFF7D108

/*
 * Location of the users' stored
 * general registers relative to R0.
 * Usage is u.u_ar0[XX].
 *
 *	For the Butterfly-2:
 *		u.u_ar0 will point to the exception 
 *		frame.  All offsets will be > 0.
 */

#define PC		XF_snip
#define PSW		XF_tpsr
#define PS		PSW
#define SP		XF_r31
#define	AP		XF_r30
#define RECOVERYFRAME	XF_recovery

#define	NIPCREG	38

#ifndef	ASSEMBLER
struct regs {
	int	r_r[32];	/* Registers R0-R31 */
        int     r_sxip;		/* Execution PC */
        int     r_snip;		/* Next PC */
        int     r_sfip;		/* Fetch PC */
        int     r_sr;           /* Status Register */
        int     r_fpsr;		/* FP Status Register */
        int     r_fpcr;		/* FP Control Register */
};
#endif	!ASSEMBLER
