#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */ 
 
#endif	CMU
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)scb.h	7.1 (Berkeley) 6/5/86
 */

/*
 * VAX System control block layout
 */

struct scb {
        int	scb_sp;		        /* reset sp */
	int	scb_pc;   	        /* reset pc */
	int	(*scb_berr)();  	/* bus error */
	int	(*scb_illinstr)();	/* illegal instruction */
	int	(*scb_div0)();  	/* integer divide by zero */
	int	(*scb_chk_chk2)();	/* chk/chk2 trap*/
	int	(*scb_tpcc_tpv)();	/* trapcc cptrapcc trapv */
	int	(*scb_privinstr)();	/* priviledged instruction */
	int	(*scb_trace)();		/* trace  */
	int	(*scb_line1010)();	/* line 1010 emulator */
	int	(*scb_line1111)();	/* line 1111 emulator */
	int	(*scb_resvd1)();	/* reserved */
	int	(*scb_coprot)();	/* coprocessor protocol violation */
	int	(*scb_format)();	/* instruction format */
	int	(*scb_uni_int)();       /* unintialized interrupt */
	int	(*scb_resvd2[8])();     /* reserved */
	int	(*scb_spurious)();	/* spurious interrupt */
	int	(*scb_ilevel[7])();	/* interrupts level 1-7 */
	int	(*scb_trap[16])();	/* traps 0-15 */
	int	(*scb_fp_unord)();	/* FP branch on unordered condition */
	int	(*scb_fp_inexct)();	/* FP inexact results */
	int	(*scb_fp_div0)();	/* FP divide by zero */
	int	(*scb_fp_under)();	/* FP underflow */
	int	(*scb_fp_operr)();	/* FP operand error */
	int	(*scb_fp_over)();	/* FP overflow */
	int     (*scb_fp_nan)();        /* FP not-a-number */
	int	(*scb_resvd3)();        /* reserved */
	int	(*scb_mm_config)();	/* MMU configuration trap */
	int	(*scb_mm_illop)();	/* MMU illegal operation */
	int	(*scb_mm_access)();     /* MMU access violation */
	int	(*scb_resvd4[5])();     /* reserved */
	int	(*scb_uvectors[128])();	/* user defined vectors */
};

#ifdef KERNEL
extern	struct scb scb;
/* scb.scb_ubaint is the same as UNIvec */
#endif

#define	scbentry(f)		((int (*)()) (((int)f)))
