/*
 ****************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 ****************************************************************
 * HISTORY
 *  1-Sep-86  Michael Young (mwyoung) at Carnegie-Mellon University
 *	Created from mach_syscalls.h in the user library sources.
 *
 */

#ifndef	_MACHINE_SYSCALL_SW_
#define	_MACHINE_SYSCALL_SW_	1

#define kernel_trap(trap_name, trap_number) 	NEWLINEXXX \
	text				NEWLINEXXX \
	global	_/**/trap_name; 	NEWLINEXXX \
_/**/trap_name: 			NEWLINEXXX \
	subu	r31, r31, 8		NEWLINEXXX \
	st	r1, r31, r0		NEWLINEXXX \
	or	r9, r0, lo16(trap_number) NEWLINEXXX \
	or.u	r9,r9,hi16(trap_number)	NEWLINEXXX \
	tb0	0, r0, 128		NEWLINEXXX \
	ld	r1, r31, r0		NEWLINEXXX \
	addu	r31, r31, 8		NEWLINEXXX \
	jmp	r1

#endif	_MACHINE_SYSCALL_SW_
