/* $Header: clock_c.h,v 1.4 89/02/25 01:40:58 gibson Exp $ */
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */ 
/***********************************************************************
* HISTORY
*
* 20-Apr-87 Gregg Bromley adds back some vax like definitions
*
* 23-Mar-87 Tom Calderwood begins BBN version (by scrapping CMU version)
*
*/ 
 
#endif	CMU
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)clock.h	7.1 (Berkeley) 6/5/86
 */



#define SECDAY          ((unsigned)(24*60*60))          /* seconds per day */
#define SECYR           ((unsigned)(365*SECDAY))        /* per common year */

#ifndef butterfly
/*
 * TODRZERO is the what the TODR should contain when the ``year'' begins.
 * The TODR should always contain a number between 0 and SECYR+SECDAY.
 */
#define TODRZERO        ((unsigned)(1<<28))
#endif butterfly

#define YRREF           1970
#define LEAPYEAR(year)  ((year)%4==0)   /* good till time becomes negative */

#ifndef butterfly
/*
 * Has the time-of-day clock wrapped around?
 */
#define clkwrap()       (((unsigned)(TODR) - TODRZERO)/100 > SECYR+SECDAY)
#endif butterfly

extern long cpu;
