/* $Header: /nfs/europa/u1/BFMACH.local/mk/bflyc/RCS/cpu_c.h,v 1.22 90/07/31 22:12:07 lkaplan Exp $ */
/*
 * Definitions for cpu parameters - kchin
 */

#ifndef _CPU_C_
#define _CPU_C_

#include "../h/types.h"

#ifdef KERNEL
/* random information about nodes */
#define	master_cpu	0	/* logical node number of master */
#define	MASTER_CPU	0	/* logical node number of master */
extern int	phys_master_cpu; /* physical node number of master */
extern int	mach_cpus;	/* number of mach nodes */
extern int	bare_bpnes;	/* number of bare bpne nodes */
extern int	bare_bvmes;	/* number of bare bvme nodes */
extern int	log_node_count;	/* total number of nodes */

extern int	my_cpu_number;	/* vectorized: initialized at beginning
				   of slave execution. */
extern short  log_node_map[];	/* array mapping physical to logical nodes */
#define	NULL_NODE	999	/* in log_node_map -> phys node not present */
extern short  log_to_phys_map[];/* array mapping logical to physical nodes */

extern int slaves_started;		/* have slaves been started yet? */

#define NODE_DESCHED	(-1)
#define UNIX_MASTER()	unix_switch(MASTER_CPU);
#define UNIX_SLAVE()	unix_switch(current_proc()->p_home_pnn);
#define UNIX_DESCHED()	unix_switch(NODE_DESCHED);

#endif KERNEL

/*
 * CPU types.
 * Similar types are grouped with their earliest examples.
 */
#define BFLY_PLUS 1

#ifndef LOCORE
/*
 * Per-cpu information for system (i.e information about each CPU the code
 * will suport).
 */
struct	percpu {
	short	pc_cputype;		/* cpu type code */
#ifdef BFLY1
	short	pc_niob;		/* number of different IO busses */
	struct	iobus *pc_io;		/* descriptions of different IO buses*/
#endif BFLY1
};

#ifdef KERNEL
extern struct percpu percpu[];
#endif KERNEL
#endif LOCORE

#endif _CPU_C_
