/* $Header: /nfs/columbia/u1/BFMACH.local/mk/bflyc/RCS/param_c.h,v 1.15 91/01/08 09:24:34 tappan Exp $ */
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */ 
#endif	CMU

/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)machparam.h	7.1 (Berkeley) 6/5/86
 */
#ifndef _MACHINE_PARAM_
#define	_MACHINE_PARAM_

#ifdef	KERNEL
#include "cs_generic.h"

/* On the butterfly, all information about system
 * page size flows from vm_param.h
 */
#include "../butterfly/vm_param.h"
#include "../machine/endian.h"
#else	KERNEL
#include <sys/features.h>
#include <machine/vm_param.h>
#include <machine/endian.h>
#endif	KERNEL

/*
 * maximum processes per node calculations
 */
#define MAXPROCPER4MEGNODE 64
#define MAXPROCPER16MEGNODE 200

/*
 * Machine dependent constants for Butterfly.
 */
#define	NBPG	VM_PAGESIZE		/* bytes/page */
#define	PGSHIFT	VM_PAGESHIFT		/* LOG2(NBPG) */

#define	PGOFSET	(NBPG-1)	/* byte offset into page */
#define	BUFSIZE	8192		/* size of buffers in buffer pool??## */

#define	CLSIZE		1
#define	CLSIZELOG2	0

#define	SSIZE	1		/* initial stack size/NBPG */
#define	SINCR	1		/* increment of stack/NBPG */

#define UPAGES  1

/*
 * Some macros for units conversion
 */
/* Core clicks (8192 bytes) to segments and vice versa */
#define	ctos(x)	(x)
#define	stoc(x)	(x)

/* Core clicks (8192 bytes) to disk blocks */
#define	ctod(x)	((x)<<4)
#define	dtoc(x)	(((unsigned)(x)+15)>>4)
#define	dtob(x)	((x)<<9)

/* clicks to bytes */
#define	ctob(x)	((x)<<VM_PAGESHIFT)

/* bytes to clicks */
#define	btoc(x)	(((unsigned)(x)+(NBPG-1))>>VM_PAGESHIFT)

/*
 * Macros to decode processor status word.
 */
#define	USERMODE(ps)	(((ps) & PSW_SUPER) == 0)
#define	BASEPRI(ps)	(((ps) & PSW_IPL) == 0)

#ifndef KERNEL
#define	DELAY(n)	{ register int N = (n); while (--N > 0); }
#endif KERNEL

#ifdef KERNEL
#include	"../machine/kerneldefs.h"
#endif KERNEL

#endif _MACHINE_PARAM_
