/* $Header: /nfs/europa/u1/BFMACH.local/mk/bflyc/RCS/vmap_c.h,v 1.3 90/12/13 14:59:53 gibson Exp $ */
#ifndef _VMAP_C_H
#define	_VMAP_C_H
#ifndef ASSEMBLER

#ifdef KERNEL
#include "bbn_split_pgtab.h"
#endif KERNEL

/* A "space" (16 Meg of virtual address space) is a standard unit for 
 * various kernel functions.
 */
#define	SPACE_SIZE	0x01000000
#define	btospace(sp)	(((unsigned)(sp)) / SPACE_SIZE)

/*****************************************************************************
* Layout of Kernel Virtual Address Space
******************************************************************************/

/* User address space defines */
#define	USER_MIN_VADDR		0x00000000
#define	USER_MAX_VADDR		0xC0000000

	/* KERNEL_TEXT_VADDR is not only the virtual address where 
	 * kernel text begins, it is also used to define where the
	 * kernel is linked for.  kernel data and chunk pool are
	 * assumed to be at fixed offsets from kernel text
	 *
	 * To change address kernel is linked for, need to change
	 * these definitions and the ones in kload.defs that have
	 * the Makefile tell the loader what to do.
	 */
#ifdef BFLY1
#define	KERNEL_TEXT_VADDR	0xC0000000
#endif BFLY1
#ifdef BFLY2
#define	KERNEL_TEXT_VADDR	0x80000000
#endif BFLY2

#define	KERNEL_DATA_VADDR	(KERNEL_TEXT_VADDR + SPACE_SIZE)
#define	CHUNK_POOL_VADDR	(KERNEL_TEXT_VADDR + (3*SPACE_SIZE))

#ifdef BFLY1
#define	PUCP_SPACE_VADDR	0xE0000000
#endif BFLY1

#ifdef BFLY2
#define	CHUNK_HOLE_VADDR	0xE0000000
#define	B2VME_REGS_VADDR	0xE0700000
#define	B2VME_REGS_SIZE		0x00100000
#endif BFLY2

#define	KERNEL_MAX_ALLOC_VADDR	0xF0000000

#ifdef BFLY2
#define	_VEC_VME_SLAVE_MAP	0xF4000000
#define	LOCAL_VME_VADDR		0xF7000000
#endif BFLY2

#define	SCRATCH_PTES_VADDR	0xF8000000
#define	VECTORIZED_SPACE_VADDR	0xF9000000
#define	SCRATCH_SPACE_VADDR	0xFA000000
#define	U_AREA_SPACE_VADDR	0xFB000000

#ifdef BFLY2
#define	_VEC_VME_MASTER_MAP	0xFC000000
#endif BFLY2

#define	PHYS_MAP_VADDR		0xFE000000

#ifdef BFLY1
#define	PNC_SPACE_VADDR		0xFF000000
#endif BFLY1
#ifdef BFLY2
#define	IPROC_INTR_SPACE_VADDR	0xFF000000
#endif BFLY2

/*
 * Look at pmap.doc.h for the full story on how these segments are used.
 */

/* 16-Meg segments in kernel virtual address space */

#define	KTEXT_SPACE	btospace(KERNEL_TEXT_VADDR)	/* e.g. C0 on BFLY1 */
	/* Kernel data seg (may include more segs) */
#define	KDATA_SPACE	btospace(KERNEL_DATA_VADDR)
#define	SCRATCH_SPACE	0xF8	/* Disk driver: virtual access to phys mem */
#define	VEC_SPACE	0xF9	/* access other node's vetorized pages */
#define	BOOT_SPACE	0xFA	/* scratch to copy data to slaves */
#define	U_AREA_SPACE	0xFB	/* u-area and kernel stack are in the */
#define	KSTACK_SPACE	0xFB	/* same segment */
#define LOC_PHYS_SPACE	0xFE	/* maps physical memory on local node */

/*
 * We divide our 4 Gbyte virtual address space (shared between user and
 * kernel) into 256 "segments", each mapping 2048 pages of 8K bytes.
 */

#define P0SPACES	0xC0		/* number of virtual segments in P0 */
#if BBN_SPLIT_PGTAB==0
#define SYSSPACES	0x40		/* number of virtual segments in P1 */
#endif BBN_SPLIT_PGTAB

#ifdef BFLY1
/* On BFLY2, BOOTINFO_BASE is part of low 64K */
#define _BOOTINFO_BASE	0xFE3C0000      /* location of boot params on slaves */

#define	BERR_VECT_ADDR	0xC0012008	/* offset of berr in vector table */
#endif BFLY1

extern char start_vectorized;
#define	VECPG_VADDR	(&start_vectorized)

/* this is the the 8K page holding the kernel stack. */
#define U_AREA_STPAGE_VADDR	0XFBFFC000
#ifdef BFLY2
/* this is the 4K page the stack cannot go below */
#define	KERNEL_STACK_VADDR	0xFBFFD000
#endif BFLY2
#define	U_AREA_VADDR		0xFBFFE000
#define	U_AREA_MAX_VADDR	0xFBFFFFFF
/* assortment of useful virtual address constants */
#define	KERNEL_MAX_VADDR	0xFFFFFFFF



#ifdef KERNEL

/*****************************************************************************
* Definitions for address space
******************************************************************************/

extern	int 	etext;
extern	int	end;

#define	KTEXT_SIZE		((vm_offset_t)(vm_round_page(		\
				      (vm_offset_t)&etext & ~0xFF000000)))
#define	KDATA_SIZE		((vm_offset_t)(vm_round_page(		\
				      (vm_offset_t)&end & ~0xFF000000)))

#define INTSTACK_SIZE		VM_PAGESIZE	 /* interrupt stack size */
#define	KERNEL_MAX_VIRT_SIZE	KERNEL_MAX_ALLOCATED_ADDR-KERNEL_TEXT_VADDR

#endif KERNEL

#endif ASSEMBLER
#endif	_VMAP_C_H

