/* $Header: /nfs/europa/u1/BFMACH.local/mk/butterflydev/RCS/icc_ringbuf.h,v 1.3 90/11/26 16:14:16 tdonahue Exp $ */

#ifndef ICC_RINGBUF_H
#define ICC_RINGBUF_H

typedef struct icc_osdata_s 
{
  /* 
   * Common fields 
   */
  unsigned int	ostype;		/* Operating system identifier (pSOS or nX) */
  unsigned int	pnn;		/* PNN of pending process                   */
  unsigned int	ringbuf_po;	/* Physical offset of local ring buffer     */
  /* 
   * OS-specific fields 
   */
  union 
    {
      struct			/* nX-specific information */
	{
	  unsigned int  pid;		/* nX process ID       */
	  unsigned long channel; 	/* Wakeup channel      */
	} nx_data;
      struct			/* pSOS-specific information */
	{
	  unsigned int  tid;		/* pSOS task ID        */
	  unsigned long event;		/* pSOS event bit mask */
	} psos_data;
    } os;
} ICC_OSDATA;


typedef struct icc_ringbuf_s 
{
  unsigned int	lock;
  int		len;
  int		head;
  int		tail;
  ICC_OSDATA	buf[1];
} ICC_RINGBUF;


/*
 * Ring Buffer Size and Offset
 *
 * Must match pSOS definitions!
 */
#ifndef PSOS_OS
#define ICC_RINGBUF_PO    (0x00012000)
#endif
#define ICC_RINGBUF_SIZE      (0x2000)

/* 
 * Ring buffer memory allocation macro
 */
#define N_OSDATA_BUFS ((ICC_RINGBUF_SIZE-sizeof(ICC_RINGBUF)) / \
		                sizeof(ICC_OSDATA))

#endif	ICC_RINGBUF_H
