/* $Header: /nfs/europa/u1/BFMACH.local/mk/h/RCS/gistpoints.h,v 1.14 90/12/07 13:33:50 lkaplan Exp $ */
/* This file declares the standard kernel gist points.    */
/* it is subject to postprocessing so please don't        */
/* make format changes.                                   */

#define ELOG_PID_POINT      200 /* pid                         %d */
#define ELOG_TRIGGER_POINT  201 /* trigger                   0x%x */
#define ELOG_SYSCALL_POINT1 210 /* syscall             %<syscall> TOP*/
#define ELOG_SYSCALL_POINT2 211 /* syscall(fp)         %<kernsym> */
#define ELOG_SYSCALL_POINT3 212 /* syscall-done        %<syscall> TOP*/
#define ELOG_SWTCH_POINT1   220 /* run-done                     - TOP*/
#define ELOG_SWTCH_POINT3   221 /* switch-io(dev)            0x%x TOP*/
#define ELOG_SWTCH_POINT4   222 /* switch-to(lnode)            %d TOP*/
#define ELOG_SWTCH_POINT2   223 /* run                          - TOP*/
#define ELOG_FAULT_POINT1   230 /* fault(va)                 0x%x TOP*/
#define ELOG_FAULT_POINT2   231 /* pgalloc-before(op)        0x%x */
#define ELOG_FAULT_POINT3   232 /* pgresident(pp)            0x%x */
#define ELOG_FAULT_POINT4   233 /* hardfault(voffs)          0x%x */
#define ELOG_FAULT_POINT5   234 /* zerofill(before)             - */
#define ELOG_FAULT_POINT6   235 /* zerofill(after)              - */
#define ELOG_FAULT_POINT7   236 /* privatize(before)            - */
#define ELOG_FAULT_POINT8   237 /* privatize(after)             - */
#define ELOG_FAULT_POINT9   238 /* pg_add_mapping(pa)        0x%x */
#define ELOG_FAULT_POINT9A  239 /* pmap_enter(pa)            0x%x */
#define ELOG_FAULT_POINT9B  240 /* pmap_enter-done              - */
#define ELOG_FAULT_POINT10  241 /* pg_add_mapping(done)         - */
#define ELOG_FAULT_POINT10A 242 /* pg_remov_mappngs(pa)      0x%x */
#define ELOG_FAULT_POINT10B 243 /* pg_remov_mappngs(lstlen)    %d */
#define ELOG_FAULT_POINT10C 244 /* kernel-shoot(vaddr)       0x%x */
#define ELOG_FAULT_POINT10D 245 /* kernel-shoot(after)          - */
#define ELOG_FAULT_POINT10G 248 /* pmap_range_remov(sva)     0x%x */
#define ELOG_FAULT_POINT10H 249 /* pmap_range_remov(eva)     0x%x */
#define ELOG_FAULT_POINT11  250 /* pp_lookup(object)         0x%x */
#define ELOG_FAULT_POINT12  251 /* pp_lookup(bktsiz)           %d */
#define ELOG_FAULT_POINT12A 252 /* fault-done(patw)          0x%x TOP*/
#define ELOG_FAULT_POINT12B 253 /* oem3f(va)                 0x%x */
#define ELOG_FAULT_POINT12C 254 /* oem3f-done(nva)           0x%x */
#define ELOG_FAULT_POINT13  260 /* vnode_lookup(object)      0x%x */
#define ELOG_FAULT_POINT14  261 /* vnode_lookup(bktsiz)        %d */
#define ELOG_FAULT_POINT15  262 /* vmlock-wait(caller) %<kernsym> */
#define ELOG_FAULT_POINT16  263 /* vlnowt-fail(caller) %<kernsym> */
#define ELOG_FAULT_POINT17  264 /* vm_unlock(caller)   %<kernsym> */
#define ELOG_SCHED_POINT1   265 /* sched(lnode)                %d */
#define ELOG_SCHED_POINT2   266 /* sched-done(lnode)           %d */
#define ELOG_SCHED_POINT3   267 /* sleep(chan)               0x%x TOP*/
#define ELOG_SCHED_POINT4   268 /* sleep-got-signal             ? */
#define ELOG_SCHED_POINT5   269 /* sleep-done(issig)           %d TOP*/
#define ELOG_SCHED_POINT6   270 /* sleep-unlock(chan)        0x%x TOP*/
#define ELOG_SCHED_POINT7   271 /* sleep-unlock(lockp)       0x%x TOP*/
#define ELOG_SCHED_POINT8   272 /* sleep-unlock-got-signal      ? */
#define ELOG_SCHED_POINT9   273 /* sleep-unlock-done(issig)    %d TOP*/
#define ELOG_SCHED_POINT10  274 /* wakeup-done(isall)          %d TOP*/
#define ELOG_SCHED_POINT11  275 /* wakeup(chan)              0x%x TOP*/
#define ELOG_SCHED_POINT12  276 /* idle-thread                  - */
#define ELOG_SCHED_POINT13  415 /* sleep(caller)       %<kernsym> */
#define ELOG_SCHED_POINT14  416 /* sleep(c2)           %<kernsym> */
#define ELOG_SCHED_POINT15  417 /* sleep(c3)           %<kernsym> */
#define ELOG_USU_POINT1     277 /* user-sleep-unlock(chan)   0x%x */
#define ELOG_USU_POINT2     278 /* user-sleep-unlock(lockp)  0x%x */
#define ELOG_USU_POINT3     279 /* user-sleep-awakened          - */
#define ELOG_USU_POINT4     280 /* user-sleep-timeout(chan)  0x%x TOP*/
#define ELOG_USU_POINT5     281 /* user-wakeup(chan)         0x%x */
#define ELOG_USU_POINT6     282 /* user-yield                   - */
#define ELOG_USU_POINT7     283 /* user-nopreempt(flagva)    0x%x */
#define ELOG_USU_POINT7A    284 /* user-nopreempt(timeoutva) 0x%x */
#define ELOG_USU_POINT8     285 /* preempt-suppressed           - TOP*/
#define ELOG_TLB_POINT1     286 /* tlb-int-for(lnode)          %d */
#define ELOG_TLB_POINT2     287 /* tlb-int                      - */
#define ELOG_TLB_POINT3     288 /* tlb-int-done                 - */
#define ELOG_TLB_POINT4     289 /* tlb-update(va)            0x%x */
#define ELOG_TLB_POINT5     290 /* tlb-update-done(va)       0x%x */
#define ELOG_TLB_POINT6     291 /* mtpr(ftype)                 %d */
#define ELOG_TLB_POINT7     292 /* mtpr(va)                  0x%x */
#define ELOG_TLB_POINT7A    293 /* mtpr(caller)              0x%x */
#define ELOG_TLB_POINT8     294 /* mtpr-done(va)             0x%x */
#define ELOG_TLB_POINT9     295 /* inval-patcs(start)           - */
#define ELOG_TLB_POINT10    296 /* inval-patcs(done)            - */
#define ELOG_TLB_POINT11    297 /* mmu-flusha(start)            - */
#define ELOG_TLB_POINT12    298 /* mmu-flusha(done)             - */
#define ELOG_TLB_POINT13    299 /* cmmu-flushs(va)           0x%x */
#define ELOG_TLB_POINT14    300 /* cmmu-flushs-done(va)      0x%x */
#define ELOG_TLB_POINT15    301 /* clean-dcache(start)          - */
#define ELOG_TLB_POINT16    302 /* clean-dcache(done)           - */
#define ELOG_TLB_POINT17    303 /* dirty-dcache(start)          - */
#define ELOG_TLB_POINT18    304 /* dirty-dcache(done)           - */
#define ELOG_TLB_POINT19    305 /* cpbck-dcache(start)          - */
#define ELOG_TLB_POINT20    306 /* cpbck-dcache(end)            - */
#define ELOG_TLB_POINT21    307 /* cpbck-dcache-pg(pa)       0x%x */
#define ELOG_TLB_POINT22    308 /* cpbck-dcache-pg-done(pa)  0x%x */
#define ELOG_TLB_POINT23    309 /* inv-dcache(mmu)           0x%x */
#define ELOG_TLB_POINT24    310 /* inv-dcache-done(mmu)      0x%x */
#define ELOG_TLB_POINT25    311 /* inv-dcache-pg(paddr)      0x%x */
#define ELOG_TLB_POINT26    312 /* inv-dcache-pg-done(paddr) 0x%x */
#define ELOG_TLB_POINT27    313 /* cpbck-inv-dc(mmu)         0x%x */
#define ELOG_TLB_POINT28    314 /* cpbck-inv-dc-done(mmu)    0x%x */
#define ELOG_TLB_POINT29    315 /* cpbck-inv-pg(paddr)       0x%x */
#define ELOG_TLB_POINT30    316 /* cpbck-inv-pg-done(paddr)  0x%x */
#define ELOG_TLB_POINT31    317 /* vm-cache_flush(addr)      0x%x */
#define ELOG_TLB_POINT32    318 /* vm-cache-flush(size)      0x%x */
#define ELOG_TLB_POINT33    319 /* vm-cache-flush(flags)     0x%x */
#define ELOG_TLB_POINT34    320 /* vm-cache-flush-done(addr) 0x%x */
#define ELOG_IO_POINT1      321 /* vn-rdwr(vp)               0x%x */
#define ELOG_IO_POINT2      322 /* vn-rdwr-done(vp)          0x%x */
#define ELOG_IO_POINT3      323 /* rwip(ip)                  0x%x */
#define ELOG_IO_POINT4      324 /* bmap(ip)                  0x%x */
#define ELOG_IO_POINT5      325 /* bmap-done(retval)         0x%x */
#define ELOG_IO_POINT6      326 /* bread(blkno)                %d */
#define ELOG_IO_POINT7      327 /* bread-hit-done(blkno)       %d */
#define ELOG_IO_POINT8      328 /* bread-miss-done(blkno)      %d */
#define ELOG_IO_POINT9      330 /* breada(blkno,rablkno)       %d */
#define ELOG_IO_POINT10     331 /* breada-hit(bp)            0x%x */
#define ELOG_IO_POINT11     332 /* breada-miss(bp)           0x%x */
#define ELOG_IO_POINT12     333 /* breada-hit(rabp)          0x%x */
#define ELOG_IO_POINT13     334 /* breada-miss(rabp)         0x%x */
#define ELOG_IO_POINT14     335 /* bwrite(blkno)               %d */
#define ELOG_IO_POINT15     336 /* bwrite-done(bp)           0x%x */
#define ELOG_IO_POINT16     337 /* bdwrite(blkno)              %d */
#define ELOG_IO_POINT17     338 /* bdwrite-done(bp)          0x%x */
#define ELOG_IO_POINT18     339 /* spec-rdwr-read(dev)       0x%x */
#define ELOG_IO_POINT18A    340 /* spec-rdwr-read(blk)         %d */
#define ELOG_IO_POINT19     341 /* spec-rdwr-write(dev)      0x%x */
#define ELOG_IO_POINT19A    342 /* spec-rdwr-write(blk)        %d */
#define ELOG_IO_POINT20     343 /* spec-rdwr-done(blk)         %d */
#define ELOG_UNUSED_POINT1  344 /* UNUSED	               %d */
#define ELOG_UNUSED_POINT1A 345 /* UNUSED		       %d */
#define ELOG_UNUSED_POINT1B 346 /* UNUSED		       %d */
#define ELOG_UNUSED_POINT2  347 /* UNUSED		     0x%x */
#define ELOG_UNUSED_POINT3  348 /* UNUSED		     0x%x */
#define ELOG_UNUSED_POINT4  349 /* UNUSED		     0x%x */
#define ELOG_UNUSED_POINT5  350 /* UNUSED		     0x%x */
#define ELOG_UNUSED_POINT6  351 /* UNUSED		     0x%x */
#define ELOG_UNUSED_POINT7  352 /* UNUSED		       %d */
#define ELOG_UNUSED_POINT8  353 /* UNUSED		       %d */
#define ELOG_SIGNAL_POINT1  354 /* signal(pid)                 %d TOP*/
#define ELOG_SIGNAL_POINT2  355 /* signal(sig)                  ? */
#define ELOG_SIGNAL_POINT3  356 /* signal-done(sig)            %d TOP*/
#define ELOG_SIGNAL_POINT4  357 /* issig(p_sig)              0x%x */
#define ELOG_SIGNAL_POINT5  358 /* issig-done(sig)             %d */
#define ELOG_SIGNAL_POINT6  359 /* checksig(p_sig)           0x%x */
#define ELOG_SIGNAL_POINT7  360 /* checksig-done(sig)          %d */
#define ELOG_SIGNAL_POINT8  361 /* handle(sig)                 %d TOP*/
#define ELOG_SIGNAL_POINT9  362 /* handle-done(sig)            %d TOP*/
#define ELOG_CLOCK_POINT1   363 /* hardclock                    - */
#define ELOG_CLOCK_POINT2   364 /* hardclock-done(needsoft)    %d */ 
#define ELOG_CLOCK_POINT3   365 /* softclock                    - */ 
#define ELOG_CLOCK_POINT4   366 /* impintr                      - */ 
#define ELOG_CLOCK_POINT5   367 /* ipintr                       - */ 
#define ELOG_CLOCK_POINT3A  368 /* softclock-done               - */ 
#define ELOG_CLOCK_POINT6   369 /* profile-pc(va)            0x%x TOP*/
#define ELOG_SG_POINT1      375 /* stripe-blkno                %d */
#define ELOG_SG_POINT2      376 /* stripe-b_bcount             %d */
#define ELOG_SG_POINT3      377 /* stripe-pbn-begin            %d */
#define ELOG_SG_POINT4      378 /* stripe-pbn-end              %d */
#define ELOG_SG_POINT5      379 /* stripe-async                %d */
#define ELOG_SG_POINT6      380 /* stripe-sd-wait-begin        %x */
#define ELOG_SG_POINT7      381 /* stripe-sd-wait-end          %x */
#define ELOG_SG_POINT8      382 /* stripe-sd-nowait-begin      %x */
#define ELOG_SG_POINT9      383 /* stripe-sd-nowait-end        %x */
#define ELOG_SG_POINT10     384 /* stripe-sha-start            %x */
#define ELOG_SG_POINT11     385 /* stripe-sha-intr             %x */
#define ELOG_INACT_POINT1   400 /* scan-deferred	       %d */
#define ELOG_INACT_POINT2   401 /* scan-age-counts	       %d */
#define ELOG_INACT_POINT3   402 /* scan-abort-after-age	       %d */
#define ELOG_INACT_POINT4   403 /* scan-resume-step	       %d */
#define ELOG_INACT_POINT5   404 /* scan-start-pmaps	       %d */
#define ELOG_INACT_POINT6   405 /* scan-pmap		     0x%x */
#define ELOG_INACT_POINT7   406 /* scan-pmap-is-active	     0x%x */
#define ELOG_INACT_POINT8   407 /* scan-pmap-abort-ptes	       %d */
#define ELOG_INACT_POINT9   408 /* scan-pmap-done-ptes	       %d */
#define ELOG_INACT_POINT10  409 /* scan-pmap-tot-inval	       %d */
#define ELOG_INACT_POINT11  410 /* scan-pmap-disabled	     0x%x */
#define ELOG_INACT_POINT12  411 /* scan-finished-pmaps	       %d */
#define ELOG_INACT_POINT13  412 /* scan-abort-scan	       %d */
#define ELOG_INACT_POINT14  413 /* scan-abort-inactivate       %d */
#define ELOG_INACT_POINT15  414 /* scan-inactivated-pages      %d */
#define ELOG_LOCK_POINT1    430 /* lock-wait(addr)     %<kernsym> */
#define ELOG_LOCK_POINT2    431 /* lock-wait(caller)   %<kernsym> */
