/*
 ****************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 ****************************************************************
 */

#ifndef	_NOTIFY_
#define	_NOTIFY_	1

/*
 *	Kernel notification message definitions.
 *
 * HISTORY
 * 21-Nov-86  Michael Young (mwyoung) at Carnegie-Mellon University
 *	Added notification message structure definition.
 *
 * 01-Jul-86  Michael Young (mwyoung) at Carnegie-Mellon University
 *	Created, based on Accent values.
 */

#ifdef	KERNEL
#include "../h/message.h"
#else	KERNEL
#include <sys/message.h>
#endif	KERNEL

/*
 *	Notifications sent upon interesting system events.
 */

#define	NOTIFY_FIRST			0100
#define	NOTIFY_PORT_DELETED		( NOTIFY_FIRST + 001 )
#define	NOTIFY_MSG_ACCEPTED		( NOTIFY_FIRST + 002 )
#define	NOTIFY_OWNERSHIP_RIGHTS		( NOTIFY_FIRST + 003 )
#define	NOTIFY_RECEIVE_RIGHTS		( NOTIFY_FIRST + 004 )
#define	NOTIFY_LAST			( NOTIFY_FIRST + 015 )

typedef struct {
	msg_header_t	notify_header;
	msg_type_t	notify_type;
	port_t		notify_port;
} notification_t;

#endif	_NOTIFY_
