/* $Header: ptrace.h,v 1.8 90/01/13 11:15:09 rwells Exp $ */

/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */
 
/*
 * Copyright (c) 1980, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)ptrace.h	7.1 (Berkeley) 6/4/86
 */

#ifndef _PTRACE_
#define _PTRACE_

#ifdef	KERNEL
#include "cputypes.h"
#else	KERNEL
#include <sys/features.h>
#endif	KERNEL


#define PT_TRACE_ME	0	/* child declares it's being traced */
#define PT_READ_I	1	/* read word in child's I space */
#define PT_READ_D	2	/* read word in child's D space */
#define PT_READ_U	3	/* read word in child's user structure */
#define PT_WRITE_I	4	/* write word in child's I space */
#define PT_WRITE_D	5	/* write word in child's D space */
#define PT_WRITE_U	6	/* write word in child's user structure */
#define PT_CONTINUE	7	/* continue the child */
#define PT_KILL		8	/* kill the child process */
#define PT_STEP		9	/* single step the child */
#define PT_ATTACH	10	/* attach to an existing process */
#define PT_DETACH	11	/* detach from a process */
#define PT_GETREGS	12	/* get all regs */
#define PT_SETREGS	13	/* set all regs */
#define PT_GETFPREGS	14	/* get all fp regs */
#define PT_SETFPREGS	15	/* set all fp regs */
#define PT_READDATA	16	/* read from data segment */
#define PT_WRITEDATA	17	/* write to data segment */
#define PT_READTEXT	18	/* read  fromtext segment */
#define PT_WRITETEXT	19	/* write to text segment */
#define PT_SETSIGMASK   20	/* set ptrace signal mask */

#endif _PTRACE_
