
/* $Header: /nfs/columbia/u1/BFMACH.local/mk/h/RCS/systm.h,v 1.13 91/01/16 12:01:11 tappan Exp $ */
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */
#endif	CMU
 
#ifdef	KERNEL
#include "cs_boot.h"
#include "cs_generic.h"
#include "cs_rpause.h"
#else	KERNEL
#include <sys/features.h>
#endif	KERNEL
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)systm.h	7.1 (Berkeley) 6/4/86
 *	@(#)systm.h	2.1 88/05/18 4.0NFSSRC SMI; from 7.1 (Berkeley) 6/4/86
 */

#if	CS_RPAUSE
#ifdef	KERNEL
#include "../h/boolean.h"
#else	KERNEL
#include <sys/boolean.h>
#endif	KERNEL

#endif	CS_RPAUSE
/*
 * Random set of variables
 * used by more than one
 * routine.
 */
extern	char version[];		/* system version */

/*
 * Nblkdev is the number of entries
 * (rows) in the block switch. It is
 * set in binit/bio.c by making
 * a pass over the switch.
 * Used in bounds checking on major
 * device numbers.
 */
extern int	nblkdev;

/*
 * Number of character switch entries.
 * Set by cinit/prim.c
 */
extern int	nchrdev;

int	nswdev;			/* number of swap devices */
int	mpid;			/* generic for unique process id's */
char	runin;			/* scheduling flag */
char	runout;			/* scheduling flag */

extern int ast;			/* Overlaps the following */
extern char new_signal;		/* new signal for current process */
extern char runrun;		/* higher priority process ready */
extern char do_profile;		/* profiling needed for current proc. */
/* Masks for the different bytes in 'ast' */
#define AST_SIGNAL	0xff000000
#define AST_RUNRUN	0x00ff0000
#define AST_PROFILE	0x0000ff00
/* end of overlap */

extern char curpri;		/* user priority of current process */
char	kmapwnt;		/* kernel map want flag */

int	maxmem;			/* actual max memory per process */
int	physmem;		/* physical memory on this CPU */

int	nswap;			/* size of swap space */
int	updlock;		/* lock for sync */
#define	UPDLOCK_LOCKED	0x01	/* lock for sync is held */
#define	UPDLOCK_WANTED	0x02	/* lock for sync is wanted */
extern	int intstack[];		/* stack for interrupts */
dev_t	rootdev;		/* device of the root */
struct vnode *rootvp;		/* vnode of root filesystem */
dev_t	dumpdev;		/* device to take dumps on */
struct vnode	*dumpvp;	/* vnode to dump on */
long	dumplo;			/* offset into dumpdev */
long	dumpsize;

extern	int icode[];		/* user init code */
extern	int szicode;		/* its size */

daddr_t	bmap();
caddr_t	calloc();
int	memall();
int	vmemall();
caddr_t	wmemall();
swblk_t	vtod();
struct vnode *bdevvp();
struct vnode *specvp();
#if	CS_RPAUSE
boolean_t	rpause();
boolean_t	fspause();
#endif	CS_RPAUSE

/*
 * Structure of the system-entry table
 */
extern struct sysent
{
	short	sy_narg;		/* total number of arguments */
	short	sy_parallel;		/* can execute in parallel */
	int	(*sy_call)();		/* handler */
} sysent[];

int	noproc;			/* no one is running just now */
char	*panicstr;
int	wantin;
int	boothowto;		/* reboot flags, from console subsystem */
#if	CS_GENERIC
int	show_space;
#endif	CS_GENERIC
#if	CS_BOOT
u_long	bootdev;		/* boot device, from bootstrap subsystem */
#endif	CS_BOOT
int	selwait;

extern	char vmmap[];		/* poor name! */

/* casts to keep lint happy */
#define	insque(q,p)	_insque((caddr_t)q,(caddr_t)p)
#define	remque(q)	_remque((caddr_t)q)
