/* $Header: /nfs/columbia/u1/BFMACH.local/mk/kdb/RCS/defs.h,v 1.24 91/01/14 14:24:13 tappan Exp $ */
#if	CMU
/* 
 **********************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 **********************************************************************
 */ 
#endif	CMU
/*	defs.h	4.3	82/12/19	*/

/*
 * kdb - vax string table version; common definitions
 */

#include "../kdb/kdbdefine.h"

#include "../machine/psl.h"
#include "../machine/pte.h"

#include "../h/param.h"
#include "../h/dir.h"
#include "../h/user.h"

#ifdef BFLY1
#include "../kdb1/ctype.h"
#include "../kdb1/a.out.h"
#endif BFLY1
#ifdef BFLY2
#include "../kdb2/ctype.h"
#include "../kdb2/a.out.h"
#endif BFLY2

#define	ADB
#define	MULD2


#include "../h/vm.h"

#undef	TRUE
#undef	FALSE

#include "../kdb/mac.h"
#include "mode.h"
#include "../kdb/head.h"

/* access modes */
#define RD	0
#define WT	1

#define NSP	0
#define	ISP	1
#define	DSP	2
#define STAR	4
#define STARCOM 0200

/*
 * Symbol types, used internally in calls to findsym routine.
 * One the VAX this all degenerates since I & D symbols are indistinct.
 * Basically we get NSYM==0 for `=' command, ISYM==DSYM otherwise.
 */
#define NSYM	0
#define DSYM	1		/* Data space symbol */
#define ISYM	DSYM		/* Instruction space symbol == DSYM on VAX */

#define BKPTSET	1
#define BKPTEXEC 2

#define USERPS	PSL
#define USERPC	PC
#ifdef BFLY1
#define	BPT	0x4e44	/* trap #4 for the butterfly */
#endif BFLY1
#ifdef BFLY2
#define BPT	0xF000D081	/* tb0 0,r0,129 */
#endif BFLY2
#define TBIT	020
#define FD	0200
#define	SETTRC	0
#define	RDUSER	2
#define	RIUSER	1
#define	WDUSER	5
#define WIUSER	4
#define	RUREGS	3
#define	WUREGS	6
#define	CONTIN	7
#define	EXIT	8
#define SINGLE	9

/* The following symbols are used to index into reglist directly */
#ifdef BFLY1
#define REG_A6	14
#define REG_A7	15
#define REG_PC	16
#define REG_PS	17

#define NUMREGS 18
#define	D0	0
#define	D1	4
#define	D2	8
#define	D3	12
#define	D4	16
#define	D5	20
#define	D6	24
#define	D7	28
#define	A0	32
#define	A1	36
#define	A2	40
#define	A3	44
#define	A4	48
#define	A5	52
#define	A6	56
#define AP	56
#define	A7	60
#define PC	64
#define PS	(68+sizeof(fp_context)+(UPAGES*4)+sizeof(vm_offset_t)+sizeof(root_ptr_t)+12)
#endif BFLY1

#ifdef BFLY2
#define	REG_R1	1
#define REG_R30	30
#define REG_R31	31
#define REG_PC	32
#define REG_PS	33

#define NUMREGS 34
#define	R0	0
#define	R1	4
#define	R2	8
#define	R3	12
#define	R4	16
#define	R5	20
#define	R6	24
#define	R7	28
#define R8	32
#define R9	36
#define	R10	40
#define	R11	44
#define	R12	48
#define	R13	52
#define	R14	56
#define	R15	60
#define	R16	64
#define	R17	68
#define R18	72
#define R19	76
#define	R20	80
#define	R21	84
#define	R22	88
#define	R23	92
#define	R24	96
#define	R25	100
#define	R26	104
#define	R27	108
#define R28	112
#define R29	116
#define	R30	120
#define	R31	124
#define PC	128
#define PS	132
#endif BFLY2

#define MAXOFF	0x1000
#define MAXPOS	80
#define MAXLIN	128
#define EOF	0
#define EOR	'\n'
#define SP	' '
#define TB	'\t'
#define QUOTE	0200
#define STRIP	0177
#define LOBYTE	0377
#define EVEN	-2

#ifdef vax
/* long to ints and back (puns) */
union {
	INT	I[2];
	L_INT	L;
} itolws;

#define leng(a)		itol(0,a)
#endif vax

#define shorten(a)	((short)(a))
#ifdef vax
#define itol(a,b)	(itolws.I[0]=(a), itolws.I[1]=(b), itolws.L)
#endif vax

typedef char *String, *string;

/* result type declarations */
L_INT		inkdot();
POS		get();
POS		chkget();
STRING		exform();
L_INT		round();
BKPTR		scanbkpt();
VOID		fault();

struct	pcb	pcb;
int	kernel;
int	kcore;
struct	pte *sbr;
int	slr;
int	masterpcbb;

/* vectorized */
extern struct	pcb	*curpcb; /* pcb for selected process */
extern vm_map_t	curmap;		/* vm map for selected process */
extern int		curpid;	/* process id when entering debugger */
