/*
 ****************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 ****************************************************************
 */
/*
 * HISTORY
 *  3-Dec-86  Michael Young (mwyoung) at Carnegie-Mellon University
 *	Added "single step until matching return" form of ":j".
 *
 * 6-jan-86	David Golub (dbg)
 *	declarations for new single-step features
 *
 */

int	sstepmode;
int	icount;
int	call_depth;

#define STEP_NONE	0
#define	STEP_NORM	1
#define STEP_PRINT	2
#define	STEP_CALLT	3
#define	STEP_RETURN	4

#ifdef butterfly
#define I_BSR		0x61
#define I_CALLM_MASK	0xffc0ff00
#define I_CALLM		0x06c00000
#define I_JSR_MASK	0xffc00000
#define I_JSR		0x4e800000
#define I_RTE		0x4e73
#define I_RTD		0x4e74
#define I_RTS		0x4e75
#define I_RTR		0x4e77
#define I_RTM_MASK	0xfff00000
#define I_RTM		0x06c00000
#else butterfly
#define	I_CALLG		0xfa
#define I_CALLS		0xfb
#define I_RET		0x04
#define	I_REI		0x02
#endif butterfly
