/*
 * Subtype fields for NFS allocations from the kernel memory allocator.
 * 
 * These are only used when profiling
 */

#ifndef _nfs_kmalloctypes_h
#define _nfs_kmalloctypes_h
#include "vfs_kmalloctypes.h"
#define KM_ST_NFSATTR		0x01	/* struct nfsattrstat */
#define KM_ST_RESULT		0x03	/* rpc result data */
#define KM_ST_IOVEC		0x04	/* iovec */
#define KM_ST_RFS		0x05	/* rfsget/rfsput  */
#define KM_ST_RNODE		0x06	/* rnode */
#define KM_ST_NEWNAME		0x07	/* from newname */
#define KM_ST_MACHINENAME	0x08	/* system names */
#define KM_ST_MNTPATH		0x09	/* mount path */
#define KM_ST_MNTINFO		0x0a
#define KM_ST_NETNAME 		0x0b
#define KM_ST_NFSDIROP		0x0c 	/* struct nfsdiropres */
#define KM_ST_AUTH		0x0d
#define KM_ST_CKU		0x0f
#define KM_ST_CKUOUTBUF		0x10
#define KM_ST_RPCMSG		0x11
#define KM_ST_SVCREQ		0x12
#define KM_ST_SERVER		0x13
#define KM_ST_DUPREQ		0x14
#define KM_ST_MEMALLOC		0x15
#endif _nfs_kmalloctypes_h
