/*
 * $Header: vfs_conf.c,v 1.2 89/02/25 01:29:23 gibson Exp $
 *
 *	@(#)vfs_conf.c	2.2 88/06/13 4.0NFSSRC SMI;  from SMI 1.6 87/01/27
 */

#ifdef	butterfly
#ifdef	KERNEL
#include "nfsclient.h"
#include "sun_pcfs.h"
#include "sun_lofs.h"
#include "sun_rfs.h"
#else	KERNEL
#include <sys/features.h>
#endif	KERNEL
#endif	butterfly

#include "param.h"
#include "vfs.h"
#include "bootconf.h"

extern	struct vfsops ufs_vfsops;	/* XXX Should be ifdefed */

#if	NFSCLIENT
extern	struct vfsops nfs_vfsops;
#endif

#if	SUN_PCFS
extern	struct vfsops pcfs_vfsops;
#endif

#if	SUN_LOFS
extern	struct vfsops lo_vfsops;
#endif

#if	SUN_RFS
extern	struct vfsops rfs_vfsops;
#endif

extern	struct vfsops spec_vfsops;

/* 
 * WARNING: THE POSITIONS OF FILESYSTEM TYPES IN THIS TABLE SHOULD NOT
 * BE CHANGED. These positions are used in generating fsids and fhandles.
 * Thus, changing positions will cause a server to change the fhandle it
 * gives out for a file.
 */

struct vfssw vfssw[] = {
	"spec", &spec_vfsops,		/* SPEC */
	"4.3", &ufs_vfsops,		/* UFS */
#if	NFSCLIENT
	"nfs", &nfs_vfsops,		/* NFS */
#else
	(char *)0, (struct vfsops *)0,
#endif
#if	SUN_PCFS
	"pc", &pcfs_vfsops,		/* PC */
#else
	(char *)0, (struct vfsops *)0,
#endif
#if	SUN_LOFS
	"lo", &lo_vfsops,		/* LOopback */
#else
	(char *)0, (struct vfsops *)0,
#endif
#if	SUN_RFS
	"rfs", &rfs_vfsops,		/* RFS */
#else
	(char *)0, (struct vfsops *)0,
#endif
};

#define	NVFS	(sizeof vfssw / sizeof vfssw[0])

struct vfssw *vfsNVFS = &vfssw[NVFS];

struct bootobj rootfs = {
	"ufs",           "",     0, 0, (struct vnode *)0,
};
struct bootobj dumpfile = {
	"",           "",     0, 0, (struct vnode *)0,
};
