/* $Header: vmt_test.h,v 1.4 89/08/07 21:29:56 rwells Exp $ */

/*****************************************************************************
File:     vmt_test.h
Contents: PRIVATE Definitions for testing VM subsystem.
System:   BBNACI Butterfly OS kernel, virtual memory subsystem.
Created:  8-Apr-1989
Author:   rwells & dbarach

Remarks:

Copyright 1989 by BBN Advanced Computers Inc.
ALL RIGHTS RESERVED

No part of this material may be reproduced, stored in a retrieval
system, transmitted or used in any form or by any means, electronic,
mechanical, photocopying, recording, or otherwise, without the prior
written permission of, or express license from BBN Advanced Computers Inc.

RESTRICTED RIGHTS LEGEND

Use, duplication, or disclosure by the Government is subject to
restrictions as set forth in subparagraph (c)(1)(ii) of the Rights to
Technical Data and Computer Software clause at DFARS 52.227-7013.

BBN Advanced Computers Inc.
10 Fawcett Street
Cambridge, Ma. 02238
617-873-6000
*****************************************************************************/

#ifndef _VMT_TEST_H_
#define _VMT_TEST_H_

/* ----- Counts of testing variables ------------------------------------- */

#define TEST_MAPCNT 10		/* Supports 10 maps named "M0".."M10"  */
#define TEST_PAGECNT 20		/* Supports 20 pages per node, and "P0"... */

/* ----- VM Testing function prototypes ---------------------------------- */

#if defined(__STDC__) || defined(c_plusplus)
vm_addr_t    vmt_alloc_pages(vm_size_t size);
int          vmt_atox(char *cp);
vm_inherit_t vmt_inherit(char *cp);
void         vmt_init(void);
void         vmt_list_print(int argc, char **argv);
void         vmt_map_access(int argc, char **argv);
void         vmt_map_allocate(int argc, char **argv);
void         vmt_map_create(int argc, char **argv);
void         vmt_map_deallocate(int argc, char **argv);
void         vmt_map_destroy(int argc, char **argv);
void         vmt_map_errno(int argc, char **argv);
void         vmt_map_fault(int argc, char **argv);
void         vmt_map_file(int argc, char **argv);
void         vmt_map_fork(int argc, char **argv);
void         vmt_map_inherit(int argc, char **argv);
void         vmt_map_iswired(int argc, char **argv);
vm_map_t*    vmt_map_p(char *name);
void         vmt_map_pmap(int argc, char **argv);
void         vmt_map_print(int argc, char **argv);
void         vmt_map_protect(int argc, char **argv);
void         vmt_map_set_cluster_id(int argc, char **argv);
void         vmt_map_u_area_copy(int argc, char **argv);
void         vmt_map_u_area_create(int argc, char **argv);
void         vmt_map_unwire(int argc, char **argv);
void         vmt_map_unwire_page(int argc, char **argv);
void         vmt_map_wire(int argc, char **argv);
void         vmt_map_wire_page(int argc, char **argv);
int          vmt_mapflags(char *cp);
void         vmt_mapping_cache_flush(int argc, char **argv);
void         vmt_objoff_pp_print(int argc, char **argv);
void         vmt_objoff_vnode_print(int argc, char **argv);
vm_page_t*   vmt_page_p(char *name);
vm_prot_t    vmt_protect(char *cp);
void         vmt_testit(int argc, char **argv);
#else
vm_addr_t    vmt_alloc_pages(/*see above*/);

vm_addr_t    vmt_alloc_pages(/*see above*/);
int          vmt_atox(/*see above*/);
vm_inherit_t vmt_inherit(/*see above*/);
void         vmt_init(/*see above*/);
void         vmt_list_print(/*see above*/);
void         vmt_map_access(/*see above*/);
void         vmt_map_allocate(/*see above*/);
void         vmt_map_create(/*see above*/);
void         vmt_map_deallocate(/*see above*/);
void         vmt_map_destroy(/*see above*/);
void         vmt_map_errno(/*see above*/);
void         vmt_map_fault(/*see above*/);
void         vmt_map_file(/*see above*/);
void         vmt_map_fork(/*see above*/);
void         vmt_map_inherit(/*see above*/);
void         vmt_map_iswired(/*see above*/);
vm_map_t*    vmt_map_p(/*see above*/);
void         vmt_map_pmap(/*see above*/);
void         vmt_map_print(/*see above*/);
void         vmt_map_protect(/*see above*/);
void         vmt_map_set_cluster_id(/*see above*/);
void         vmt_map_u_area_copy(/*see above*/);
void         vmt_map_u_area_create(/*see above*/);
void         vmt_map_unwire(/*see above*/);
void         vmt_map_unwire_page(/*see above*/);
void         vmt_map_wire(/*see above*/);
void         vmt_map_wire_page(/*see above*/);
int          vmt_mapflags(/*see above*/);
void         vmt_mapping_cache_flush(/*see above*/);
void         vmt_objoff_pp_print(/*see above*/);
void         vmt_objoff_vnode_print(/*see above*/);
vm_page_t*   vmt_page_p(/*see above*/);
vm_prot_t    vmt_protect(/*see above*/);
void         vmt_testit(/*see above*/);
#endif

/* ----- Test library function prototypes -------------------------------- */

#if defined(__STDC__) || defined(c_plusplus)
void         test_driver(int argc, char **argv,
			 void (*fp)(int argc, char **argv));
void         test_print_unknown(int argc, char **argv);
void         test_print_before(int argc, char **argv);
void         test_print_after(char *format, ...);
void         test_error(char *format, ...);
int          test_bool(char *name);
char        *test_bool_to_text(int flag);
int          test_index(char *argp, char *prefixp, int maxnum);
#else
void         test_driver(/*see above*/);
void         test_print_unknown(/*see above*/);
void         test_print_before(/*see above*/);
void         test_print_after(/*see above*/);
void         test_error(/*see above*/);
int          test_bool(/*see above*/);
char        *test_bool_to_text(/*see above*/);
int          test_index(/*see above*/);
#endif

/* ----- Prototypes for C library functions used in testing -------------- */

#if defined(__STDC__) || defined(c_plusplus)
void         _doprnt();		/* Used to support VARARGS */
int          atoi(char *cp);
char*        malloc(vm_size_t);
void         perror(char *name);
void         printf();		/* VARARGS */
int          sscanf(/*VARARGS*/);
int          strcmp(char *cp1, char *cp2);
int          strlen(char *cp);
int          strncmp(char *cp1, char *cp2, int len);
#else
void         _doprnt(/*see above*/);
int          atoi(/*see above*/);
char*        malloc(/*see above*/);
void         perror(/*see above*/);
void         printf(/*see above*/);
int          sscanf(/*see above*/);
int          strcmp(/*see above*/);
int          strlen(/*see above*/);
int          strncmp(/*see above*/);
#endif

/* ----- end of the file... ---------------------------------------------- */

#endif _VMT_TEST_H_
